'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 11 May 2003 at 9:25:57 pm'!

!AliceTextOutputWindow methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:12'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.627
		g: 0.909
		b: 0.972! !

!AliceTextOutputWindow methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:12'!
initialize
	"Initialize the window for output."
	super initialize.
""
	self openInWorld! !


!B3DMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:39'!
initialize
	"initialize the state of the receiver"
	super initialize.
""
	geometry _ B3DBox from: -0.7 @ -0.7 @ -0.7 to: 0.7 @ 0.7 @ 0.7.
	camera _ B3DCamera new.
	(self confirm: 'Put me into a clipping frame?')
		ifTrue: [camera position: 0 @ 0 @ 1.5]
		ifFalse: [camera position: 0 @ 0 @ 2.
			color _ nil].
	camera nearDistance: 0.1.
	camera farDistance: 5.0.
	self extent: 100 @ 100.
	texture _ (Form extent: 100 @ 100) asTexture.
	angle _ 0! !


!B3DSceneExplorerMorph methodsFor: 'actions' stamp: 'dgd 2/22/2003 13:33'!
selectNewCamera
	| menu sel |
	(self scene cameras isNil or: [self scene cameras isEmpty]) 
		ifTrue: 
			[(SelectionMenu selections: #('OK')) 
				startUpWithCaption: 'No cameras defined!!'.
			^self].
	menu := SelectionMenu selections: self scene cameras keys asArray.
	sel := menu startUp.
	sel ifNotNil: 
			[self scene defaultCamera: (self scene cameras at: sel) copy.
			b3DSceneMorph updateUpVectorForCamera: self scene defaultCamera.
			self changed]! !

!B3DSceneExplorerMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:33'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #raised! !

!B3DSceneExplorerMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color gray: 0.8! !

!B3DSceneExplorerMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:41'!
initialize
	"initialize the state of the receiver"
	| ctrl |
	super initialize.
	""
	self extent: 300 @ 300.
	
	frameWidth _ 25.
	b3DSceneMorph _ AdvancedB3DSceneMorph new.
	b3DSceneMorph color: Color black.
	self addMorphFront: b3DSceneMorph.
	wheels _ Dictionary new.
	ctrl _ WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #addFovAngle:.
	ctrl factor: -0.07.
	ctrl setBalloonText: 'FOV'.
	self addMorphFront: ctrl.
	wheels at: #fov put: ctrl.
	ctrl _ WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #addDolly:.
	ctrl factor: 0.005.
	ctrl beVertical.
	ctrl setBalloonText: 'Dolly'.
	self addMorphFront: ctrl.
	wheels at: #dolly put: ctrl.
	ctrl _ WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #rotateZ:.
	ctrl beVertical.
	ctrl setBalloonText: 'z Axis'.
	self addMorphFront: ctrl.
	wheels at: #rotZ put: ctrl.
	ctrl _ WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #rotateY:.
	ctrl setBalloonText: 'y Axis'.
	self addMorphFront: ctrl.
	wheels at: #rotY put: ctrl.
	ctrl _ WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #rotateX:.
	ctrl beVertical.
	ctrl setBalloonText: 'x Axis'.
	self addMorphFront: ctrl.
	wheels at: #rotX put: ctrl.
	ctrl _ self acceleratorButton.
	self addMorphFront: ctrl.
	wheels at: #accel put: ctrl! !


!B3DSceneMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 17:30'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self createDefaultScene; beTransparent! !


!AdvancedB3DSceneMorph methodsFor: 'camera actions' stamp: 'gm 2/28/2003 00:18'!
updateHeadlight
	| headLight camera |
	camera := scene defaultCamera.
	headLight := (self scene lights isKindOf: Dictionary) 
		ifTrue: [self scene lights at: '$HeadLight$' ifAbsent: []]
		ifFalse: [nil].
	headLight ifNil: 
			[(headLightStatus = #on and: [self scene lights isKindOf: Dictionary]) 
				ifTrue: 
					[self scene lights at: '$HeadLight$' put: savedHeadLight.
					headLight := savedHeadLight]]
		ifNotNil: 
			[headLightStatus = #off 
				ifTrue: 
					[savedHeadLight := headLight.
					self scene lights removeKey: '$HeadLight$']].
	headLight ifNotNil: 
			[headLight
				position: camera position;
				target: camera target]! !

!AdvancedB3DSceneMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 17:31'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self stepTime: 0;
		 rotationAngle: 1;
		 beRotating;
		 switchHeadLightOn ! !


!ChessBoard methodsFor: 'copying' stamp: 'aoy 2/17/2003 01:15'!
copyBoard: aBoard 
	"Copy all volatile state from the given board"

	whitePlayer copyPlayer: aBoard whitePlayer.
	blackPlayer copyPlayer: aBoard blackPlayer.
	activePlayer := aBoard activePlayer isWhitePlayer 
				ifTrue: [whitePlayer]
				ifFalse: [blackPlayer]. 
	hashKey := aBoard hashKey.
	hashLock := aBoard hashLock.
	userAgent := nil! !

!ChessBoard methodsFor: 'copying' stamp: 'aoy 2/17/2003 01:16'!
postCopy
	whitePlayer := whitePlayer copy.
	blackPlayer := blackPlayer copy.
	activePlayer := whitePlayer == activePlayer 
				ifTrue: [whitePlayer]
				ifFalse: [blackPlayer]. 
	whitePlayer opponent: blackPlayer.
	blackPlayer opponent: whitePlayer.
	whitePlayer board: self.
	blackPlayer board: self.
	self userAgent: nil! !

!ChessBoard methodsFor: 'hashing' stamp: 'aoy 2/17/2003 01:17'!
updateHash: piece at: square from: player 
	| index |
	index := player == whitePlayer ifTrue: [piece] ifFalse: [piece + 6].
	hashKey := hashKey bitXor: ((HashKeys at: index) at: square). 
	hashLock := hashLock bitXor: ((HashLocks at: index) at: square)! !

!ChessBoard methodsFor: 'moving' stamp: 'aoy 2/17/2003 01:16'!
nextMove: aMove 
	activePlayer applyMove: aMove.
	userAgent 
		ifNotNil: [userAgent completedMove: aMove white: activePlayer isWhitePlayer].
	activePlayer := activePlayer == whitePlayer 
				ifTrue: [blackPlayer]
				ifFalse: [whitePlayer].
	activePlayer prepareNextMove ! !

!ChessBoard methodsFor: 'moving' stamp: 'aoy 2/17/2003 01:16'!
nullMove
	activePlayer := activePlayer == whitePlayer 
				ifTrue: [blackPlayer]
				ifFalse: [whitePlayer]. 
	activePlayer prepareNextMove! !

!ChessBoard methodsFor: 'moving' stamp: 'aoy 2/17/2003 01:17'!
undoMove: aMove 
	activePlayer := activePlayer == whitePlayer 
				ifTrue: [blackPlayer]
				ifFalse: [whitePlayer]. 
	activePlayer undoMove: aMove.
	userAgent 
		ifNotNil: [userAgent undoMove: aMove white: activePlayer isWhitePlayer]! !


!ChessMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:17'!
defaultBorderColor
"answer the default border color/fill style for the receiver"
	^ #raised! !

!ChessMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:17'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 5! !

!ChessMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:26'!
defaultBounds
	"answer the default bounds for the receiver"
	^ 0 @ 0 corner: 410 @ 410! !

!ChessMorph methodsFor: 'initialization' stamp: 'jam 3/9/2003 16:47'!
defaultColor
	"answer the receiver's default color"
	| result |
	result _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.05
							g: 0.5
							b: 1.0). 1.0
					-> (Color
							r: 0.85
							g: 0.95
							b: 1.0)}.
	result origin: self bounds origin;
		 direction: self extent.
	result radial: false.
	^ result! !

!ChessMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:26'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	animateMove _ false.
	autoPlay _ false.

	self cornerStyle: #rounded.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight;
		 wrapDirection: #bottomToTop.
	self addSquares.
	self addButtonRow.
	self newGame! !


!ChessMoveGenerator methodsFor: 'public' stamp: 'gm 2/28/2003 01:41'!
findAllPossibleMovesFor: player 
	"Find all possible moves. This method does not check if the move is legal, e.g., if the king of the player is under attack after the move. If the opponent is check mate (e.g., the king could be taken in the next move) the method returns nil. If the game is stale mate (e.g., the receiver has no move left) this method returns an empty array."

	| piece actions square |
	myPlayer := player.
	myPieces := player pieces.
	itsPieces := player opponent pieces.
	castlingStatus := player castlingStatus.
	enpassantSquare := player opponent enpassantSquare.
	firstMoveIndex = lastMoveIndex ifFalse: [self error: 'I am confused'].
	kingAttack := nil.
	actions := myPlayer isWhitePlayer 
		ifTrue: 
			[#(#moveWhitePawnAt: #moveKnightAt: #moveBishopAt: #moveRookAt: #moveQueenAt: #moveWhiteKingAt:)]
		ifFalse: 
			[#(#moveBlackPawnAt: #moveKnightAt: #moveBishopAt: #moveRookAt: #moveQueenAt: #moveBlackKingAt:)].
	square := 0.
	[square < 64] whileTrue: 
			["Note: The following is only to skip empty fields efficiently.
		It could well be replaced by going through each field and test it
		for zero but this is *much* faster."

			square := String 
						findFirstInString: myPieces
						inSet: EmptyPieceMap
						startingAt: square + 1.
			square = 0 ifTrue: [^self moveList].
			piece := myPieces at: square.
			self perform: (actions at: piece) with: square.
			kingAttack ifNotNil: [^self moveList]].
	^self moveList! !

!ChessMoveGenerator methodsFor: 'public' stamp: 'dgd 2/22/2003 14:38'!
findAttackSquaresFor: player 
	"Mark all the fields of a board that are attacked by the given player.
	The pieces attacking a field are encoded as (1 << Piece) so that we can
	record all types of pieces that attack the square."

	| move square piece attack list |
	forceCaptures := false.
	attackSquares ifNil: [attackSquares := ByteArray new: 64].
	attackSquares atAllPut: 0.
	list := self findAllPossibleMovesFor: player.
	
	[move := list next.
	move isNil] whileFalse: 
				[square := move destinationSquare.
				piece := move movingPiece.
				attack := attackSquares at: square.
				attack := attack bitOr: (1 bitShift: piece).
				attackSquares at: square put: attack].
	self recycleMoveList: list.
	^attackSquares! !

!ChessMoveGenerator methodsFor: 'support' stamp: 'dgd 2/22/2003 18:50'!
canCastleWhiteKingSide
	(castlingStatus bitAnd: CastlingEnableKingSide) = 0 ifFalse: [^false].
	"Quickly check if all the squares are zero"
	^(myPieces sixth) + (myPieces seventh) + (itsPieces sixth) 
		+ (itsPieces seventh) = 0! !

!ChessMoveGenerator methodsFor: 'support' stamp: 'dgd 2/22/2003 18:50'!
canCastleWhiteQueenSide
	(castlingStatus bitAnd: CastlingEnableQueenSide) = 0 ifFalse: [^false].
	"Quickly check if all the squares are zero"
	^(myPieces second) + (myPieces third) + (myPieces fourth) 
		+ (itsPieces second) + (itsPieces third) 
		+ (itsPieces fourth) = 0! !


!ChessPlayer methodsFor: 'testing' stamp: 'dgd 2/22/2003 18:41'!
canCastleKingSide
	(castlingStatus bitAnd: CastlingEnableKingSide) = 0 ifFalse: [^false].
	self isWhitePlayer 
		ifTrue: 
			[(pieces sixth) = 0 ifFalse: [^false].
			pieces seventh = 0 ifFalse: [^false].
			(opponent pieceAt: 6) = 0 ifFalse: [^false].
			(opponent pieceAt: 7) = 0 ifFalse: [^false]]
		ifFalse: 
			[(pieces at: 62) = 0 ifFalse: [^false].
			(pieces at: 63) = 0 ifFalse: [^false].
			(opponent pieceAt: 62) = 0 ifFalse: [^false].
			(opponent pieceAt: 63) = 0 ifFalse: [^false]].
	^true! !

!ChessPlayer methodsFor: 'testing' stamp: 'dgd 2/22/2003 18:41'!
canCastleQueenSide
	(castlingStatus bitAnd: CastlingEnableQueenSide) = 0 ifFalse: [^false].
	self isWhitePlayer 
		ifTrue: 
			[pieces second = 0 ifFalse: [^false].
			(pieces third) = 0 ifFalse: [^false].
			pieces fourth = 0 ifFalse: [^false].
			(opponent pieceAt: 2) = 0 ifFalse: [^false].
			(opponent pieceAt: 3) = 0 ifFalse: [^false].
			(opponent pieceAt: 4) = 0 ifFalse: [^false]]
		ifFalse: 
			[(pieces at: 58) = 0 ifFalse: [^false].
			(pieces at: 59) = 0 ifFalse: [^false].
			(pieces at: 60) = 0 ifFalse: [^false].
			(opponent pieceAt: 58) = 0 ifFalse: [^false].
			(opponent pieceAt: 59) = 0 ifFalse: [^false].
			(opponent pieceAt: 60) = 0 ifFalse: [^false]].
	^true! !


!ChessPlayerAI methodsFor: 'accessing' stamp: 'jdl 3/28/2003 08:12'!
statusString
	| av count |
	^String streamContents: 
			[:s | 
			(myMove == #none or: [myMove isNil]) 
				ifFalse: 
					[s
						print: myMove value * 0.01;
						space].
			av := bestVariation.
			count := av first.
			count > 0 
				ifFalse: 
					[av := activeVariation.
					count := av first].
			count > 0 
				ifFalse: 
					[s nextPutAll: '***'.
					av := variations first.
					count := av first.
					count := count min: 3].
			2 to: count + 1
				do: 
					[:index | 
					s nextPutAll: (ChessMove decodeFrom: (av at: index)) moveString.
					s space].
			s nextPut: $[.
			s print: nodesVisited.
			"		s nextPut:$|.
		s print: ttHits.
		s nextPut: $|.
		s print: alphaBetaCuts.
"
			s nextPut: $]]! !

!ChessPlayerAI methodsFor: 'searching' stamp: 'dgd 2/22/2003 14:44'!
copyVariation: move 
	| av mv count |
	count := 0.
	av := variations at: ply + 1.
	ply < 9 
		ifTrue: 
			[mv := variations at: ply + 2.
			count := mv first.
			av 
				replaceFrom: 3
				to: count + 2
				with: mv
				startingAt: 2].
	av at: 1 put: count + 1.
	av at: 2 put: move encodedMove! !

!ChessPlayerAI methodsFor: 'searching' stamp: 'dgd 2/22/2003 14:44'!
mtdfSearch: theBoard score: estimate depth: depth 
	"An implementation of the MTD(f) algorithm. See:
		http://www.cs.vu.nl/~aske/mtdf.html
	"

	| beta move value low high goodMove |
	value := estimate.
	low := AlphaBetaMinVal.
	high := AlphaBetaMaxVal.
	[low >= high] whileFalse: 
			[beta := value = low ifTrue: [value + 1] ifFalse: [beta := value].
			move := self 
						searchMove: theBoard
						depth: depth
						alpha: beta - 1
						beta: beta.
			stopThinking ifTrue: [^move].
			move ifNil: [^move].
			value := move value.
			value < beta 
				ifTrue: [high := value]
				ifFalse: 
					["NOTE: It is important that we do *NOT* return a move from a search which didn't reach the beta goal (e.g., value < beta). This is because all it means is that we didn't reach beta and the move returned is not the move 'closest' to beta but just one that triggered cut-off. In other words, if we'd take a move which value is less than beta it could mean that this move is a *LOT* worse than beta."

					low := value.
					goodMove := move.
					activeVariation 
						replaceFrom: 1
						to: activeVariation size
						with: (variations first)
						startingAt: 1]].
	^goodMove! !

!ChessPlayerAI methodsFor: 'searching' stamp: 'dgd 2/22/2003 14:45'!
negaScout: theBoard depth: depth alpha: initialAlpha beta: initialBeta 
	"Modified version to return the move rather than the score"

	| move score alpha bestScore moveList newBoard beta goodMove a b notFirst |
	self assert: [initialAlpha < initialBeta].
	ply < 10 ifTrue: [(variations at: ply + 1) at: 1 put: 0].
	ply := 0.
	alpha := initialAlpha.
	beta := initialBeta.
	bestScore := AlphaBetaMinVal.

	"Generate new moves"
	moveList := generator findPossibleMovesFor: theBoard activePlayer.
	moveList ifNil: [^nil].
	moveList isEmpty 
		ifTrue: 
			[generator recycleMoveList: moveList.
			^nil].

	"Sort move list according to history heuristics"
	moveList sortUsing: historyTable.

	"And search"
	a := alpha.
	b := beta.
	notFirst := false.
	[(move := moveList next) isNil] whileFalse: 
			[newBoard := (boardList at: ply + 1) copyBoard: theBoard.
			newBoard nextMove: move.
			"Search recursively"
			"Search recursively"
			ply := ply + 1.
			score := 0 - (self 
								ngSearch: newBoard
								depth: depth - 1
								alpha: 0 - b
								beta: 0 - a).
			(notFirst and: [score > a and: [score < beta and: [depth > 1]]]) 
				ifTrue: 
					[score := 0 - (self 
										ngSearch: newBoard
										depth: depth - 1
										alpha: 0 - beta
										beta: 0 - score)].
			notFirst := true.
			ply := ply - 1.
			stopThinking 
				ifTrue: 
					[generator recycleMoveList: moveList.
					^move].
			score = AlphaBetaIllegal 
				ifFalse: 
					[score > bestScore 
						ifTrue: 
							[ply < 10 ifTrue: [self copyVariation: move].
							goodMove := move copy.
							goodMove value: score.
							activeVariation 
								replaceFrom: 1
								to: activeVariation size
								with: variations first
								startingAt: 1.
							bestScore := score].
					"See if we can cut off the search"
					score > a 
						ifTrue: 
							[a := score.
							a >= beta 
								ifTrue: 
									[transTable 
										storeBoard: theBoard
										value: score
										type: (ValueBoundary bitOr: (ply bitAnd: 1))
										depth: depth
										stamp: stamp.
									historyTable addMove: move.
									alphaBetaCuts := alphaBetaCuts + 1.
									generator recycleMoveList: moveList.
									^goodMove]].
					b := a + 1]].
	transTable 
		storeBoard: theBoard
		value: bestScore
		type: (ValueAccurate bitOr: (ply bitAnd: 1))
		depth: depth
		stamp: stamp.
	generator recycleMoveList: moveList.
	^goodMove! !

!ChessPlayerAI methodsFor: 'searching' stamp: 'dgd 2/22/2003 14:45'!
ngSearch: theBoard depth: depth alpha: initialAlpha beta: initialBeta 
	"A basic alpha-beta algorithm; based on negaMax rather than from the text books"

	| move score alpha entry bestScore moveList newBoard beta a b notFirst |
	self assert: [initialAlpha < initialBeta].
	ply < 10 ifTrue: [(variations at: ply + 1) at: 1 put: 0].
	depth = 0 
		ifTrue: 
			[^self 
				quiesce: theBoard
				alpha: initialAlpha
				beta: initialBeta].
	nodesVisited := nodesVisited + 1.
	"See if there's already something in the transposition table. If so, skip the entire search."
	entry := transTable lookupBoard: theBoard.
	alpha := initialAlpha.
	beta := initialBeta.
	(entry isNil or: [entry depth < depth]) 
		ifFalse: 
			[ttHits := ttHits + 1.
			(entry valueType bitAnd: 1) = (ply bitAnd: 1) 
				ifTrue: [beta := entry value max: initialBeta]
				ifFalse: [alpha := 0 - entry value max: initialAlpha].
			beta > initialBeta ifTrue: [^beta].
			alpha >= initialBeta ifTrue: [^alpha]].
	bestScore := AlphaBetaMinVal.

	"Generate new moves"
	moveList := generator findPossibleMovesFor: theBoard activePlayer.
	moveList ifNil: [^0 - AlphaBetaIllegal].
	moveList isEmpty 
		ifTrue: 
			[generator recycleMoveList: moveList.
			^bestScore].

	"Sort move list according to history heuristics"
	moveList sortUsing: historyTable.

	"And search"
	a := alpha.
	b := beta.
	notFirst := false.
	[(move := moveList next) isNil] whileFalse: 
			[newBoard := (boardList at: ply + 1) copyBoard: theBoard.
			newBoard nextMove: move.
			"Search recursively"
			ply := ply + 1.
			score := 0 - (self 
								ngSearch: newBoard
								depth: depth - 1
								alpha: 0 - b
								beta: 0 - a).
			(notFirst and: [score > a and: [score < beta and: [depth > 1]]]) 
				ifTrue: 
					[score := 0 - (self 
										ngSearch: newBoard
										depth: depth - 1
										alpha: 0 - beta
										beta: 0 - score)].
			notFirst := true.
			ply := ply - 1.
			stopThinking 
				ifTrue: 
					[generator recycleMoveList: moveList.
					^score].
			score = AlphaBetaIllegal 
				ifFalse: 
					[score > bestScore 
						ifTrue: 
							[ply < 10 ifTrue: [self copyVariation: move].
							bestScore := score].
					score > a 
						ifTrue: 
							[a := score.
							a >= beta 
								ifTrue: 
									[transTable 
										storeBoard: theBoard
										value: score
										type: (ValueBoundary bitOr: (ply bitAnd: 1))
										depth: depth
										stamp: stamp.
									historyTable addMove: move.
									alphaBetaCuts := alphaBetaCuts + 1.
									generator recycleMoveList: moveList.
									^score]].
					b := a + 1]].
	transTable 
		storeBoard: theBoard
		value: bestScore
		type: (ValueAccurate bitOr: (ply bitAnd: 1))
		depth: depth
		stamp: stamp.
	generator recycleMoveList: moveList.
	^bestScore! !

!ChessPlayerAI methodsFor: 'searching' stamp: 'dgd 2/22/2003 14:46'!
quiesce: theBoard alpha: initialAlpha beta: initialBeta 
	"A variant of alpha-beta considering only captures and null moves to obtain a quiet position, e.g. one that is unlikely to change heavily in the very near future."

	| move score alpha entry bestScore moveList newBoard beta |
	self assert: [initialAlpha < initialBeta].
	ply < 10 ifTrue: [(variations at: ply + 1) at: 1 put: 0].
	nodesVisited := nodesVisited + 1.
	"See if there's already something in the transposition table."
	entry := transTable lookupBoard: theBoard.
	alpha := initialAlpha.
	beta := initialBeta.
	entry isNil 
		ifFalse: 
			[ttHits := ttHits + 1.
			(entry valueType bitAnd: 1) = (ply bitAnd: 1) 
				ifTrue: [beta := entry value max: initialBeta]
				ifFalse: [alpha := 0 - entry value max: initialAlpha].
			beta > initialBeta ifTrue: [^beta].
			alpha >= initialBeta ifTrue: [^alpha]].
	ply < 2 
		ifTrue: 
			["Always generate moves if ply < 2 so that we don't miss a move that
		would bring the king under attack (e.g., make an invalid move)."

			moveList := generator findQuiescenceMovesFor: theBoard activePlayer.
			moveList ifNil: [^0 - AlphaBetaIllegal]].

	"Evaluate the current position, assuming that we have a non-capturing move."
	bestScore := theBoard activePlayer evaluate.
	"TODO: What follows is clearly not the Right Thing to do. The score we just evaluated doesn't take into account that we may be under attack at this point. I've seen it happening various times that the static evaluation triggered a cut-off which was plain wrong in the position at hand.
	There seem to be three ways to deal with the problem. #1 is just deepen the search. If we go one ply deeper we will most likely find the problem (although that's not entirely certain). #2 is to improve the evaluator function and make it so that the current evaluator is only an estimate saying if it's 'likely' that a non-capturing move will do. The more sophisticated evaluator should then take into account which pieces are under attack. Unfortunately that could make the AI play very passive, e.g., avoiding situations where pieces are under attack even if these attacks are outweighed by other factors. #3 would be to insert a null move here to see *if* we are under attack or not (I've played with this) but for some reason the resulting search seemed to explode rapidly. I'm uncertain if that's due to the transposition table being too small (I don't *really* think so but it may be) or if I've just got something else wrong."
	bestScore > alpha 
		ifTrue: 
			[alpha := bestScore.
			bestScore >= beta 
				ifTrue: 
					[moveList ifNotNil: [generator recycleMoveList: moveList].
					^bestScore]].

	"Generate new moves"
	moveList ifNil: 
			[moveList := generator findQuiescenceMovesFor: theBoard activePlayer.
			moveList ifNil: [^0 - AlphaBetaIllegal]].
	moveList isEmpty 
		ifTrue: 
			[generator recycleMoveList: moveList.
			^bestScore].

	"Sort move list according to history heuristics"
	moveList sortUsing: historyTable.

	"And search"
	[(move := moveList next) isNil] whileFalse: 
			[newBoard := (boardList at: ply + 1) copyBoard: theBoard.
			newBoard nextMove: move.
			"Search recursively"
			ply := ply + 1.
			score := 0 - (self 
								quiesce: newBoard
								alpha: 0 - beta
								beta: 0 - alpha).
			stopThinking 
				ifTrue: 
					[generator recycleMoveList: moveList.
					^score].
			ply := ply - 1.
			score = AlphaBetaIllegal 
				ifFalse: 
					[score > bestScore 
						ifTrue: 
							[ply < 10 ifTrue: [self copyVariation: move].
							bestScore := score].
					"See if we can cut off the search"
					score > alpha 
						ifTrue: 
							[alpha := score.
							score >= beta 
								ifTrue: 
									[transTable 
										storeBoard: theBoard
										value: score
										type: (ValueBoundary bitOr: (ply bitAnd: 1))
										depth: 0
										stamp: stamp.
									historyTable addMove: move.
									alphaBetaCuts := alphaBetaCuts + 1.
									generator recycleMoveList: moveList.
									^bestScore]]]].
	transTable 
		storeBoard: theBoard
		value: bestScore
		type: (ValueAccurate bitOr: (ply bitAnd: 1))
		depth: 0
		stamp: stamp.
	generator recycleMoveList: moveList.
	^bestScore! !

!ChessPlayerAI methodsFor: 'searching' stamp: 'dgd 2/22/2003 14:46'!
search: theBoard depth: depth alpha: initialAlpha beta: initialBeta 
	"A basic alpha-beta algorithm; based on negaMax rather than from the text books"

	| move score alpha entry bestScore moveList newBoard beta |
	self assert: [initialAlpha < initialBeta].
	ply < 10 ifTrue: [(variations at: ply + 1) at: 1 put: 0].
	depth = 0 
		ifTrue: 
			[^self 
				quiesce: theBoard
				alpha: initialAlpha
				beta: initialBeta].
	nodesVisited := nodesVisited + 1.
	"See if there's already something in the transposition table. If so, skip the entire search."
	entry := transTable lookupBoard: theBoard.
	alpha := initialAlpha.
	beta := initialBeta.
	(entry isNil or: [entry depth < depth]) 
		ifFalse: 
			[ttHits := ttHits + 1.
			(entry valueType bitAnd: 1) = (ply bitAnd: 1) 
				ifTrue: [beta := entry value max: initialBeta]
				ifFalse: [alpha := 0 - entry value max: initialAlpha].
			beta > initialBeta ifTrue: [^beta].
			alpha >= initialBeta ifTrue: [^alpha]].
	bestScore := AlphaBetaMinVal.

	"Generate new moves"
	moveList := generator findPossibleMovesFor: theBoard activePlayer.
	moveList ifNil: [^0 - AlphaBetaIllegal].
	moveList isEmpty 
		ifTrue: 
			[generator recycleMoveList: moveList.
			^bestScore].

	"Sort move list according to history heuristics"
	moveList sortUsing: historyTable.

	"And search"
	[(move := moveList next) isNil] whileFalse: 
			[newBoard := (boardList at: ply + 1) copyBoard: theBoard.
			newBoard nextMove: move.
			"Search recursively"
			ply := ply + 1.
			score := 0 - (self 
								search: newBoard
								depth: depth - 1
								alpha: 0 - beta
								beta: 0 - alpha).
			stopThinking 
				ifTrue: 
					[generator recycleMoveList: moveList.
					^score].
			ply := ply - 1.
			score = AlphaBetaIllegal 
				ifFalse: 
					[score > bestScore 
						ifTrue: 
							[ply < 10 ifTrue: [self copyVariation: move].
							bestScore := score].
					"See if we can cut off the search"
					score > alpha 
						ifTrue: 
							[alpha := score.
							score >= beta 
								ifTrue: 
									[transTable 
										storeBoard: theBoard
										value: score
										type: (ValueBoundary bitOr: (ply bitAnd: 1))
										depth: depth
										stamp: stamp.
									historyTable addMove: move.
									alphaBetaCuts := alphaBetaCuts + 1.
									generator recycleMoveList: moveList.
									^bestScore]]]].
	transTable 
		storeBoard: theBoard
		value: bestScore
		type: (ValueAccurate bitOr: (ply bitAnd: 1))
		depth: depth
		stamp: stamp.
	generator recycleMoveList: moveList.
	^bestScore! !

!ChessPlayerAI methodsFor: 'searching' stamp: 'dgd 2/22/2003 14:47'!
searchMove: theBoard depth: depth alpha: initialAlpha beta: initialBeta 
	"Modified version to return the move rather than the score"

	| move score alpha bestScore moveList newBoard beta goodMove |
	self assert: [initialAlpha < initialBeta].
	ply < 10 ifTrue: [(variations at: ply + 1) at: 1 put: 0].
	ply := 0.
	alpha := initialAlpha.
	beta := initialBeta.
	bestScore := AlphaBetaMinVal.

	"Generate new moves"
	moveList := generator findPossibleMovesFor: theBoard activePlayer.
	moveList ifNil: [^nil].
	moveList isEmpty 
		ifTrue: 
			[generator recycleMoveList: moveList.
			^nil].

	"Sort move list according to history heuristics"
	moveList sortUsing: historyTable.

	"And search"
	[(move := moveList next) isNil] whileFalse: 
			[newBoard := (boardList at: ply + 1) copyBoard: theBoard.
			newBoard nextMove: move.
			"Search recursively"
			ply := ply + 1.
			score := 0 - (self 
								search: newBoard
								depth: depth - 1
								alpha: 0 - beta
								beta: 0 - alpha).
			stopThinking 
				ifTrue: 
					[generator recycleMoveList: moveList.
					^move].
			ply := ply - 1.
			score = AlphaBetaIllegal 
				ifFalse: 
					[score > bestScore 
						ifTrue: 
							[ply < 10 ifTrue: [self copyVariation: move].
							goodMove := move copy.
							goodMove value: score.
							bestScore := score].
					"See if we can cut off the search"
					score > alpha 
						ifTrue: 
							[alpha := score.
							score >= beta 
								ifTrue: 
									[transTable 
										storeBoard: theBoard
										value: score
										type: (ValueBoundary bitOr: (ply bitAnd: 1))
										depth: depth
										stamp: stamp.
									historyTable addMove: move.
									alphaBetaCuts := alphaBetaCuts + 1.
									generator recycleMoveList: moveList.
									^goodMove]]]].
	transTable 
		storeBoard: theBoard
		value: bestScore
		type: (ValueAccurate bitOr: (ply bitAnd: 1))
		depth: depth
		stamp: stamp.
	generator recycleMoveList: moveList.
	^goodMove! !

!ChessPlayerAI methodsFor: 'thinking' stamp: 'dgd 2/22/2003 14:47'!
think
	| move |
	self isThinking ifTrue: [^nil].
	self startThinking.
	[(move := self thinkStep) isNil] whileTrue.
	^move! !

!ChessPlayerAI methodsFor: 'thinking' stamp: 'aoy 2/15/2003 21:21'!
thinkProcess
	| score theMove depth |
	stopThinking := false.
	score := board activePlayer evaluate.
	depth := 1.
	stamp := stamp + 1.
	ply := 0.
	historyTable clear.
	transTable clear.
	startTime := Time millisecondClockValue.
	nodesVisited := ttHits := alphaBetaCuts := 0.
	bestVariation at: 1 put: 0.
	activeVariation at: 1 put: 0.
	[nodesVisited < 50000] whileTrue: 
			["whats this ? (aoy)  false ifTrue:[] ????!!"

			theMove := false 
						ifTrue: 
							[self 
								mtdfSearch: board
								score: score
								depth: depth]
						ifFalse: 
							[self 
								negaScout: board
								depth: depth
								alpha: AlphaBetaMinVal
								beta: AlphaBetaMaxVal].
			theMove ifNil: [^myProcess := nil].
			stopThinking ifTrue: [^myProcess := nil].
			myMove := theMove.
			bestVariation 
				replaceFrom: 1
				to: bestVariation size
				with: activeVariation
				startingAt: 1.
			score := theMove value.
			depth := depth + 1].
	myProcess := nil! !

!ChessPlayerAI methodsFor: 'thinking' stamp: 'dgd 2/22/2003 14:48'!
thinkStep
	transTable ifNil: [self initializeTranspositionTable].
	myProcess isNil 
		ifTrue: 
			[myMove := #none.
			false 
				ifTrue: 
					[self thinkProcess.
					^myMove].
			myProcess := [self thinkProcess] forkAt: Processor userBackgroundPriority.
			myProcess suspend.
			^nil].
	myProcess resume.
	(Delay forMilliseconds: 50) wait.
	myProcess ifNil: [^myMove == #none ifTrue: [nil] ifFalse: [myMove]].
	myProcess suspend.
	"Do we have a valid move?"
	myMove == #none ifTrue: [^nil].	"no"
	"Did we time out?"
	Time millisecondClockValue - startTime > self timeToThink 
		ifTrue: 
			["Yes. Abort and return current move."

			stopThinking := true.
			myProcess resume.
			[myProcess isNil] whileFalse: [(Delay forMilliseconds: 10) wait].
			^myMove == #none ifTrue: [nil] ifFalse: [myMove]].
	"Keep thinking"
	^nil! !


!ChessTranspositionTable methodsFor: 'initialize' stamp: 'dgd 2/22/2003 13:24'!
clear
	"Set the following to true for printing information about the fill rate and number of collisions. The transposition table should have *plenty* of free space (it should rarely exceed 30% fill rate) and *very* few collisions (those require us to evaluate positions repeatedly that we've evaluated before -- bad idea!!)"

	| entry |
	false 
		ifTrue: 
			[used position > 0 
				ifTrue: 
					['entries used:	' , used position printString , ' (' 
						, (used position * 100 // array size) printString , '%)	' 
						displayAt: 0 @ 0].
			collisions > 0 
				ifTrue: 
					['collisions:		' , collisions printString , ' (' 
						, (collisions * 100 // array size) printString , '%)	' 
						displayAt: 0 @ 15]].
	used position: 0.
	[(entry := used next) isNil] whileFalse: [entry clear].
	used resetToStart.
	collisions := 0! !


!ChineseCheckers methodsFor: 'game sequence' stamp: 'dgd 2/21/2003 23:14'!
step
	whoseMove = 0 ifTrue: [^self].	"Game over."
	plannedMove isNil 
		ifTrue: 
			[(autoPlay at: whoseMove) ifFalse: [^self].	"Waiting for a human."
			plannedMove := (self endGameFor: whoseMove) 
						ifTrue: 
							["Look deeper at the end."

							self bestMove: 2 forTeam: whoseMove]
						ifFalse: [self bestMove: 1 forTeam: whoseMove].
			movePhase := 1	"Start the animated move"].
	animateMoves 
		ifTrue: 
			["Display the move in phases..."

			movePhase > 0 ifTrue: [^self showNextMoveSegment]]
		ifFalse: 
			["... or skip the entire animated move if requested."

			self makeMove: plannedMove.
			(self pieceAt: plannedMove first)
				position: (self cellPointAt: plannedMove last);
				setBoard: self loc: plannedMove last.
			self changed.
			movePhase := 0].
	plannedMove := nil.	"End the animated move"
	self nextTurn! !

!ChineseCheckers methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:18'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.6
		g: 0.4
		b: 0.0! !

!ChineseCheckers methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:19'!
initialize
	"Default creation is for one person against Squeak."
	super initialize.
	""
	self extent: 382 @ 413.

	animateMoves _ true.
	self teams: #(2 5 ) autoPlay: {false. true}! !

!ChineseCheckers methodsFor: 'printing' stamp: 'dgd 2/21/2003 23:14'!
printOn: s 
	"For testing only"

	1 to: board size
		do: 
			[:row | 
			s
				cr;
				next: row put: $ .
			(board at: row) do: 
					[:cell | 
					s
						space;
						nextPut: (cell isNil ifTrue: [$-] ifFalse: [cell printString last])]]! !


!DownloadingImageMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:23'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color transparent! !

!DownloadingImageMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:23'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	altText _ '[image]'.

	downloadQueue _ SharedQueue new! !

!DownloadingImageMorph methodsFor: 'stepping and presenter' stamp: 'dgd 2/22/2003 14:37'!
step
	| doc |
	downloadQueue notEmpty 
		ifTrue: 
			[doc := downloadQueue next.
			doc mainType = 'image' 
				ifTrue: 
					[[image := ImageReadWriter formFromStream: doc contentStream binary] 
						ifError: 
							[:err :rcvr | 
							"ignore"

							image := nil].
					self setContents]]! !


!FreeCell methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:27'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!FreeCell methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:26'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ self colorNearTop! !

!FreeCell methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:27'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	Statistics newSession.
	autoMoveRecursionCount _ 0.
	self listDirection: #topToBottom.
	self wrapCentering: #center;
		 cellPositioning: #topCenter.
	self vResizing: #shrinkWrap.
	self hResizing: #shrinkWrap.
	self
		 addMorph: self makeControls;
		 addMorph: self board;
		 newGame! !


!FreeCellBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color green! !

!FreeCellBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:31'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self listDirection: #topToBottom;
	  hResizing: #shrinkWrap;
	  vResizing: #rigid;
	  height: 500;
	  layout! !

!FreeCellBoard methodsFor: 'private' stamp: 'dgd 2/22/2003 18:45'!
performActionSelector: actionSymbol 
	(target notNil and: [actionSelector notNil]) 
		ifTrue: [target perform: actionSelector with: actionSymbol]! !


!InterpolatingImageMorph methodsFor: 'drawing' stamp: 'dgd 2/22/2003 18:52'!
cachedImageForDepth: aDepth 
	(cachedImage notNil and: [cachedImage depth = aDepth]) 
		ifTrue: [^cachedImage].
	cachedImage := nil.	"In case we need some space"
	cachedImage := Form extent: self bounds extent depth: aDepth.
	self drawImage: image on: cachedImage getCanvas.
	^cachedImage! !

!InterpolatingImageMorph methodsFor: 'drawing' stamp: 'dgd 2/22/2003 13:46'!
drawImage: aForm on: aCanvas 
	"Draw the given form onto the canvas using the Balloon 3D engine"

	| engine |
	engine := B3DRenderEngine defaultForPlatformOn: aCanvas form.
	engine isNil ifTrue: [^self].
	"Setup the engine"
	engine viewport: aCanvas form boundingBox.
	"Install the material to be used (using a plain white emission color)"
	engine material: (B3DMaterial new emission: Color white).
	"Install the texture"
	engine texture: aForm.
	"Draw the mesh"
	engine render: B3DIndexedQuadMesh new plainTextureRect.
	"and finish"
	engine finish! !


!Mines methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:34'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #raised! !

!Mines methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:38'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!Mines methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:28'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!Mines methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:34'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self listDirection: #topToBottom;
	  wrapCentering: #center;
		 cellPositioning: #topCenter;
	  vResizing: #shrinkWrap;
	  hResizing: #shrinkWrap;
	  layoutInset: 3;
	  addMorph: self makeControls;
	  addMorph: self board.
	helpText _ nil.
	self newGame! !


!MinesBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:34'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #inset! !

!MinesBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:38'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!MinesBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:28'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!MinesBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:06'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	target _ nil.
	actionSelector _ #selection.
	arguments _ #().
	""
	self layoutPolicy: nil;
	  hResizing: #rigid;
	  vResizing: #rigid.
	""
	rows _ self preferredRows.
	columns _ self preferredColumns.
	flashCount _ 0.
	""
	self extent: self protoTile extent * (columns @ rows).
	self adjustTiles.
	self resetBoard! !


!MinesTile methodsFor: 'accessing' stamp: 'dgd 2/14/2003 21:59'!
color: aColor 
	super color: aColor.
	onColor _ aColor.
	offColor _ aColor.
	self changed! !

!MinesTile methodsFor: 'accessing' stamp: 'dgd 2/22/2003 19:09'!
doButtonAction: modifier 
	"Perform the action of this button. The first argument of the message sent to the target is the current state of this switch, 
	the second argument is the modifier button state."

	(target notNil and: [actionSelector notNil]) 
		ifTrue: 
			[^target perform: actionSelector
				withArguments: ((arguments copyWith: switchState) copyWith: modifier)]! !


!PlayingCardDeck methodsFor: 'dropping/grabbing' stamp: 'dgd 2/22/2003 18:49'!
rootForGrabOf: aCard 
	self hasSubmorphs ifFalse: [^nil].
	(target notNil and: [cardDraggedSelector notNil]) 
		ifTrue: 
			[^target 
				perform: cardDraggedSelector
				with: aCard
				with: self]
		ifFalse: [^self firstSubmorph]! !

!PlayingCardDeck methodsFor: 'events' stamp: 'dgd 2/22/2003 18:49'!
doubleClickOnCard: aCard 
	(target notNil and: [cardDoubleClickSelector notNil]) 
		ifTrue: 
			[^target 
				perform: cardDoubleClickSelector
				with: self
				with: aCard]! !

!PlayingCardDeck methodsFor: 'layout' stamp: 'dgd 2/22/2003 18:49'!
acceptDroppingMorph: aMorph event: evt 
	target rememberUndoableAction: 
			[target inAutoMove ifFalse: [target removeProperty: #stateBeforeGrab].
			self addMorph: aMorph.
			aMorph hasSubmorphs 
				ifTrue: 
					["Just dropped a sub-deck of cards"

					aMorph submorphs reverseDo: [:m | self addMorphFront: m]].
			(target notNil and: [cardDroppedSelector notNil]) 
				ifTrue: [target perform: cardDroppedSelector]]
		named: 'move card'! !

!PlayingCardDeck methodsFor: 'printing' stamp: 'dgd 2/22/2003 13:38'!
printOn: aStream 
	| cards |
	cards := self cards.
	aStream nextPutAll: 'aCardDeck('.
	cards size > 1 
		ifTrue: 
			[cards allButLast do: 
					[:card | 
					aStream
						print: card;
						nextPutAll: ', ']].
	cards notEmpty ifTrue: [aStream print: cards last].
	aStream nextPut: $)! !

!PlayingCardDeck methodsFor: 'shuffling/dealing' stamp: 'dgd 2/22/2003 13:37'!
deal
	| card |
	^ self cards notEmpty 
		ifTrue: 
			[card := self topCard.
			card delete.
			card]
		ifFalse: [nil]! !


!PlayingCardMorph methodsFor: 'event handling' stamp: 'dgd 2/22/2003 14:14'!
firstClickTimedOut: evt 
	| root popUp |
	root := owner rootForGrabOf: self.
	root isNil 
		ifTrue: 
			["Display hidden card in front"

			popUp := self copy.
			self board owner owner addMorphFront: popUp.
			self world displayWorld.
			(Delay forMilliseconds: 750) wait.
			popUp delete]
		ifFalse: [evt hand grabMorph: root]! !


!PoohTestMorph methodsFor: 'drawing' stamp: 'gm 2/28/2003 00:11'!
drawOn: aCanvas 
	| ptList last |
	super drawOn: aCanvas.
	aCanvas 
		translateBy: bounds origin
		clippingTo: self innerBounds
		during: 
			[:cc | 
			points ifNotNil: 
					[ptList := points class == Array 
						ifTrue: [points]
						ifFalse: [points contents].
					last := ptList last.
					ptList do: 
							[:next | 
							cc 
								line: last
								to: next
								width: 5
								color: (Color gray: 0.9).
							last := next]].
			self drawSubdivisionTrianglesOn: cc.
			self drawSubdivisionEdgesOn: cc.
			self drawSubdivisionSpineOn: cc].
	time ifNotNil: 
			[aCanvas 
				drawString: time printString , ' msecs'
				in: self innerBounds
				font: nil
				color: Color black]! !

!PoohTestMorph methodsFor: 'drawing' stamp: 'gm 2/28/2003 00:12'!
drawSubdivisionSpineOn: cc 
	| p1 p2 p3 center colors |
	firstPoly ifNil: [^self].
	colors := false 
		ifTrue: 
			[#(#red #green #blue #yellow #magenta #cyan) 
						collect: [:s | Color perform: s]]
		ifFalse: 
			[{Color green}].
	firstPoly validFacesDo: 
			[:poly | 
			true 
				ifTrue: 
					[p1 := p2 := p3 := nil.
					true 
						ifTrue: 
							[poly e1 fanVertices ifNil: 
									[cc 
										line: poly e1 origin
										to: poly e1 destination
										width: 1
										color: poly e1 classificationColor].
							poly e2 fanVertices ifNil: 
									[cc 
										line: poly e2 origin
										to: poly e2 destination
										width: 1
										color: poly e2 classificationColor].
							poly e3 fanVertices ifNil: 
									[cc 
										line: poly e3 origin
										to: poly e3 destination
										width: 1
										color: poly e3 classificationColor]].
					poly e1 leftFace ifNotNil: [p1 := poly e1 center].
					poly e2 leftFace ifNotNil: [p2 := poly e2 center].
					poly e3 leftFace ifNotNil: [p3 := poly e3 center].
					(p1 notNil and: [p2 notNil and: [p3 notNil]]) 
						ifTrue: 
							[center := poly center.
							poly e1 fanVertices ifNil: 
									[cc 
										line: center
										to: p1
										width: 1
										color: Color red].
							poly e2 fanVertices ifNil: 
									[cc 
										line: center
										to: p2
										width: 1
										color: Color red].
							poly e3 fanVertices ifNil: 
									[cc 
										line: center
										to: p3
										width: 1
										color: Color red]]
						ifFalse: 
							[(p1 notNil and: [p2 notNil]) 
								ifTrue: 
									[cc 
										line: p1
										to: p2
										width: 1
										color: Color red].
							(p2 notNil and: [p3 notNil]) 
								ifTrue: 
									[cc 
										line: p2
										to: p3
										width: 1
										color: Color red].
							(p3 notNil and: [p1 notNil]) 
								ifTrue: 
									[cc 
										line: p3
										to: p1
										width: 1
										color: Color red]]].
			true 
				ifTrue: 
					[poly e1 fanVertices ifNotNil: 
							[center := poly isJunction ifTrue: [poly center] ifFalse: [poly e1 center].
							poly e1 fanVertices doWithIndex: 
									[:pt :idx | 
									cc 
										line: center
										to: pt
										width: 1
										color: (colors atWrap: idx)]].
					poly e2 fanVertices ifNotNil: 
							[center := poly isJunction ifTrue: [poly center] ifFalse: [poly e2 center].
							poly e2 fanVertices doWithIndex: 
									[:pt :idx | 
									cc 
										line: center
										to: pt
										width: 1
										color: (colors atWrap: idx)]].
					poly e3 fanVertices ifNotNil: 
							[center := poly isJunction ifTrue: [poly center] ifFalse: [poly e3 center].
							poly e3 fanVertices doWithIndex: 
									[:pt :idx | 
									cc 
										line: center
										to: pt
										width: 1
										color: (colors atWrap: idx)]]]]! !

!PoohTestMorph methodsFor: 'event handling' stamp: 'dgd 2/22/2003 13:24'!
regularize: pointCollection 
	"Make the pointList non-intersecting, e.g., insert points at intersections and have the outline include those points"

	| pointList segments last intersections map pts |
	pointList := pointCollection collect: [:pt | pt asIntegerPoint].
	segments := WriteStream on: (Array new: pointList size).
	last := pointList last.
	pointList do: 
			[:next | 
			segments nextPut: (LineSegment from: last to: next).
			last := next].
	segments := segments contents.
	intersections := LineIntersections of: segments.
	map := IdentityDictionary new: segments size.
	intersections do: 
			[:is | 
			(map at: is second ifAbsentPut: [WriteStream on: (Array new: 2)]) 
				nextPut: is first.
			(map at: is third ifAbsentPut: [WriteStream on: (Array new: 2)]) 
				nextPut: is first].
	pts := WriteStream on: (Array new: pointList size).
	segments do: 
			[:seg | 
			intersections := (map at: seg) contents.
			intersections := intersections 
						sort: [:p1 :p2 | (p1 squaredDistanceTo: seg start) <= (p2 squaredDistanceTo: seg start)].
			last := intersections first.
			pts nextPut: last.
			intersections do: 
					[:next | 
					(next = last and: [next = seg end]) 
						ifFalse: 
							[pts nextPut: next.
							last := next]]].
	^pts contents collect: [:pt | pt asFloatPoint]! !

!PoohTestMorph methodsFor: 'event handling' stamp: 'jdl 3/28/2003 09:31'!
smoothen: pointList length: unitLength 
	| prevPt curPt nextPt out prevMid nextMid segment length steps deltaT |
	out := WriteStream on: (Array new: pointList size).
	prevPt := pointList at: pointList size - 1.
	curPt := pointList last.
	prevMid := (curPt + prevPt) * 0.5.
	1 to: pointList size
		do: 
			[:i | 
			nextPt := pointList at: i.
			nextMid := (nextPt + curPt) * 0.5.
			segment := Bezier2Segment 
						from: prevMid
						to: nextMid
						via: curPt.
			length := segment length.
			steps := (length / unitLength) asInteger.
			steps := steps max: 1.
			deltaT := 1.0 / steps.
			1 to: steps - 1 do: [:k | out nextPut: (segment valueAt: deltaT * k)].
			out nextPut: nextMid.
			prevPt := curPt.
			curPt := nextPt.
			prevMid := nextMid].
	^out contents! !

!PoohTestMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:47'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color white! !

!PoohTestMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:47'!
initialize
"initialize the state of the receiver"
	super initialize.
""

	self extent: 400 @ 400! !


!SameGame methodsFor: 'actions' stamp: 'aoy 2/15/2003 21:40'!
selection
	"a selection was made on the board; get its count and update the displays"

	| count score |
	count := self board selectionCount.
	count = 0 
		ifTrue: 
			[score := scoreDisplay value + (selectionDisplay value - 2) squared.
			board findSelection ifNil: 
					[count := board tilesRemaining.
					score := count = 0 
						ifTrue: [score + (5 * board rows * board columns)]
						ifFalse: [score - count].
					scoreDisplay flash: true].
			scoreDisplay value: score].
	selectionDisplay value: count! !

!SameGame methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:30'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!SameGame methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:02'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self listDirection: #topToBottom;
	  wrapCentering: #center;
		 cellPositioning: #topCenter;
	  vResizing: #shrinkWrap;
	  hResizing: #shrinkWrap;
	  layoutInset: 3;
	  addMorph: self makeControls;
	  addMorph: self board.
	helpText _ nil.
	self newGame! !


!SameGameBoard methodsFor: 'actions' stamp: 'dgd 2/22/2003 18:51'!
removeSelection
	selection ifNil: [^self].
	self rememberUndoableAction: 
			[selection do: 
					[:loc | 
					(self tileAt: loc)
						disabled: true;
						setSwitchState: false].
			self collapseColumns: (selection collect: [:loc | loc x]) asSet 
						asSortedCollection.
			selection := nil.
			flash := false.
			(target notNil and: [actionSelector notNil]) 
				ifTrue: [target perform: actionSelector withArguments: arguments]]
		named: 'remove selection'! !

!SameGameBoard methodsFor: 'actions' stamp: 'dgd 2/22/2003 18:51'!
tileClickedAt: location newSelection: isNewSelection 
	| tile |
	isNewSelection 
		ifTrue: 
			[self deselectSelection.
			tile := self tileAt: location.
			selectionColor := tile color.
			selection := OrderedCollection with: location.
			self selectTilesAdjacentTo: location.
			selection size = 1 
				ifTrue: [self deselectSelection]
				ifFalse: 
					[(target notNil and: [actionSelector notNil]) 
						ifTrue: [target perform: actionSelector withArguments: arguments]]]
		ifFalse: [self removeSelection]! !

!SameGameBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:39'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!SameGameBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:30'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color gray! !

!SameGameBoard methodsFor: 'initialization' stamp: 'dgd 2/14/2003 19:12'!
initialize
	"initialize the state of the receiver"
	super initialize.
	target _ nil.
	actionSelector _ #selection.
	arguments _ #().
	self layoutPolicy: nil.
	self hResizing: #rigid.
	self vResizing: #rigid.
	rows _ self preferredRows.
	columns _ self preferredColumns.

	palette _ (Color wheel: self preferredTileTypes + 1) asOrderedCollection.
	flashColor _ palette removeLast.
	flash _ false.
	self extent: self protoTile extent * (columns @ rows).
	self resetBoard! !

!SameGameBoard methodsFor: 'undo' stamp: 'dgd 2/22/2003 13:36'!
capturedState
	"Note the state stored in the second element is an array of associations
	from submorph index to a shallowCopy of the morph, but only for those
	morphs that change.  Therefore the capturedState record *first* delivers
	all the morphs, and *then* computes the difference and stores this back.
	In the end, both undo and redo records follow this format."

	| prior state oldMorphs priorChanges newChanges |
	(prior := self valueOfProperty: #priorState) isNil 
		ifTrue: 
			[state := { 
						self shallowCopy.	"selection, etc."
						self submorphs collect: [:m | m shallowCopy].	"state of all tiles"
						owner scoreDisplay flash.	"score display"
						owner scoreDisplay value}.
			self setProperty: #priorState toValue: state.
			^state].
	oldMorphs := prior second.
	priorChanges := OrderedCollection new.
	newChanges := OrderedCollection new.
	1 to: oldMorphs size
		do: 
			[:i | 
			(oldMorphs at: i) color = (submorphs at: i) color 
				ifFalse: 
					[priorChanges addLast: i -> (oldMorphs at: i).
					newChanges addLast: i -> (submorphs at: i) shallowCopy]].
	self removeProperty: #priorState.
	prior at: 2 put: priorChanges asArray.	"Store back into undo state.2"
	^{ 
		self shallowCopy.	"selection, etc."
		newChanges asArray.	"state of tiles that changed"
		owner scoreDisplay flash.	"score display"
		owner scoreDisplay value}! !


!SameGameTile methodsFor: 'accessing' stamp: 'dgd 2/14/2003 21:59'!
color: aColor 
	super color: aColor.
	onColor _ aColor.
	offColor _ aColor.
	self changed! !

!SameGameTile methodsFor: 'button' stamp: 'dgd 2/22/2003 19:00'!
doButtonAction
	"Perform the action of this button. The last argument of the message sent to the target is the new state of this switch."

	(target notNil and: [actionSelector notNil]) 
		ifTrue: 
			[target perform: actionSelector
				withArguments: (arguments copyWith: switchState)]! !


!TestBalloonFont methodsFor: 'tests' stamp: 'dgd 2/21/2003 22:58'!
testSpecificFont
	"(self selector: #testSpecificFont) debug"

	| aMorph |
	aMorph := RectangleMorph new.
	self assert: RectangleMorph new balloonFont = BalloonMorph balloonFont.
	self 
		assert: RectangleMorph new defaultBalloonFont = BalloonMorph balloonFont.
	aMorph balloonFont: (StrikeFont familyName: #ComicPlain size: 19).
	self 
		assert: aMorph balloonFont = (StrikeFont familyName: #ComicPlain size: 19).
	"The next test is horrible because I do no know how to access the font 
	with the appropiate interface"
	self 
		assert: (((BalloonMorph getTextMorph: 'lulu' for: aMorph) text runs first) 
				first) font 
				= (StrikeFont familyName: #ComicPlain size: 19)! !


!Tetris methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!Tetris methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:26'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	board _ TetrisBoard new game: self.
	self listDirection: #topToBottom;
	  wrapCentering: #center;
	  vResizing: #shrinkWrap;
	  hResizing: #shrinkWrap;
	  layoutInset: 3;
	  addMorphBack: self makeGameControls;
		 addMorphBack: self makeMovementControls;
		 addMorphBack: self showScoreDisplay;
		 addMorphBack: board.
	board newGame! !


!TetrisBlock methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:07'!
defaultBounds
"answer the default bounds for the receiver"
	^ (2 @ 2) negated extent: 1 @ 1! !

!TetrisBlock methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Tetris colors atRandom! !

!TetrisBlock methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:50'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	"keep this puppy out of sight"
	shapeInfo _ self class shapeChoices atRandom.
	baseCellNumber _ 4 atRandom + 2 @ 1.
	angle _ 4 atRandom! !


!TetrisBoard methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:07'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 extent: self numColumns @ self numRows * self cellSize + (1 @ 1)! !

!TetrisBoard methodsFor: 'initialization' stamp: 'dgd 2/17/2003 19:38'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color
		  lightBlue! !


!WheelMorph methodsFor: 'event handling' stamp: 'gm 2/28/2003 00:26'!
doTargetAction: cursorPoint 
	| new delta |
	new := self isHorizontal 
		ifTrue: [cursorPoint x]
		ifFalse: [cursorPoint y].
	delta := new - old.
	delta isZero ifTrue: [^self].
	self addAngle: delta.
	(target notNil and: [actionSelector notNil]) 
		ifTrue: 
			[Cursor normal showWhile: 
					[target perform: actionSelector
						withArguments: (Array with: delta * self factor)]].
	old := new! !

!WheelMorph methodsFor: 'event handling' stamp: 'gm 2/28/2003 00:27'!
mouseDown: evt 
	old := self isHorizontal 
		ifTrue: [evt cursorPoint x]
		ifFalse: [evt cursorPoint y]! !

!WheelMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:03'!
defaultBorderColor
"answer the default border color/fill style for the receiver"
	^ #raised! !

!WheelMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:03'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 1! !

!WheelMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:04'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!WheelMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:04'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self target: nil.
	self actionSelector: #flash.
	self angle: 0.
	self maxAngle: 360.
	self factor: 1.0.
	self extent: 100 @ 18.
	self beCircular.

	lastRedraw _ 0! !


!WonderlandActor methodsFor: 'eToy-support' stamp: 'gm 2/22/2003 19:00'!
tearOffTileForSelf
	| tiles |
	self currentHand attachMorph: (tiles _ self tileReferringToSelf).
	(tiles isSyntaxMorph) ifTrue:
		[Preferences tileTranslucentDrag
			ifTrue: [tiles lookTranslucent]
			ifFalse: [tiles align: tiles topLeft 
			 			with: self currentHand position + tiles cursorBaseOffset]]
! !


!WonderlandActorViewer methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:10'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.815
		g: 0.972
		b: 0.878! !

!WonderlandActorViewer methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:10'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	updatingIsOn _ false.
	self name: 'Actor Info'.
	self extent: 500 @ 350.
	
	dataMorph _ WonderlandActorData new.
	self addMorph: dataMorph.
	dataMorph topLeft: 200 @ 10! !


!WonderlandCameraControls methodsFor: 'accessing' stamp: 'dgd 2/21/2003 22:59'!
setCenter: aPoint 
	aPoint isNil 
		ifTrue: [self removeProperty: #center]
		ifFalse: [self setProperty: #center toValue: aPoint]! !

!WonderlandCameraControls methodsFor: 'camera control' stamp: 'gm 2/26/2003 00:06'!
moveCamera: evt 
	"Move the camera an amount and direction determined by the current position of the mouse and which modifier keys are held down."

	| offset dt |
	myMoveScale isNil ifTrue: [myMoveScale := 0.1].
	myRotationScale isNil ifTrue: [myRotationScale := 0.01].
	dt := myScheduler getElapsedTime.
	offset := self getCenter - (0 @ 8) - evt cursorPoint.
	evt shiftPressed 
		ifTrue: 
			[evt controlKeyPressed 
				ifTrue: 
					[myCamera 
						turnRightNow: up
						numberOfTurns: dt * offset y * myRotationScale
						undoable: false]
				ifFalse: 
					[myCamera 
						moveRightNow: up
						distance: dt * offset y * myMoveScale
						undoable: false.
					myCamera 
						moveRightNow: left
						distance: dt * offset x * myMoveScale
						undoable: false]]
		ifFalse: 
			[evt controlKeyPressed 
				ifFalse: 
					[myCamera 
						moveRightNow: forward
						distance: dt * offset y * myMoveScale
						undoable: false].
			myCamera 
				turnRightNow: left
				numberOfTurns: dt * offset x * myRotationScale
				undoable: false]! !


!WonderlandEditorTabs methodsFor: 'initialization' stamp: 'dgd 2/22/2003 14:37'!
initializeWith: aWonderland 
	"Initialize the editor with the Wonderland."

	myWonderland := aWonderland.
	myScriptEditor := WonderlandScriptEditor new.
	self addPanel: myScriptEditor getMorph.
	(self tabsMorph submorphs first) tabSelected.
	myScriptEditor setBindings: myWonderland getNamespace.
	myActorViewer := WonderlandActorViewer new.
	myActorViewer initializeWith: aWonderland.
	self addPanel: myActorViewer.
	myQuickReference := WonderlandQuickReference new.
	self addPanel: myQuickReference getMorph! !


!WonderlandActorData methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:07'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 corner: 300 @ 120! !

!WonderlandActorData methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:05'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.815
		g: 0.972
		b: 0.878! !

!WonderlandActorData methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:09'!
initialize
	"Initialize this morph by setting up the various submorphs to be  
	able to show data about a WonderlandActor"
	| aMorph |
	super initialize.
	""
	nameMorph _ TextMorph new.
	nameMorph contents: 'Name: (No actor selected)'.
	nameMorph topLeft: 10 @ 10.
	self addMorph: nameMorph.
""
	parentMorph _ TextMorph new.
	parentMorph contents: 'Parent: '.
	parentMorph topLeft: 10 @ 25.
	self addMorph: parentMorph.
""
	aMorph _ TextMorph new.
	aMorph contents: 'Position relative to parent'.
	aMorph topLeft: 10 @ 55.
	self addMorph: aMorph.
""
	positionMorph _ TextMorph new.
	positionMorph contents: Character tab asString , 'Right:    Up:    Forward: '.
	positionMorph topLeft: 10 @ 70.
	self addMorph: positionMorph.
""
	aMorph _ TextMorph new.
	aMorph contents: 'Rotation about'.
	aMorph topLeft: 10 @ 100.
	self addMorph: aMorph.
""
	rotationMorph _ TextMorph new.
	rotationMorph contents: Character tab asString , 'Left-Right axis: ' , Character cr asString , Character tab asString , 'Up-Down axis: ' , Character cr asString , Character tab asString , 'Forward-Back axis: '.
	rotationMorph topLeft: 10 @ 115.
	self addMorph: rotationMorph! !

!WonderlandActorData methodsFor: 'setting actor' stamp: 'dgd 2/21/2003 22:38'!
setActor: anActor 
	"Set the actor whose data this morph should show and update the  
	displayed data."
	| position rotation |
	anActor isNil
		ifTrue: [""nameMorph contents: 'Name: (No actor selected)'.
			parentMorph contents: 'Parent: '.
			positionMorph contents: Character tab asString , 'Right:    Up:    Forward: '.
			rotationMorph contents: Character tab asString , 'Left-Right axis: ' , Character cr asString , Character tab asString , 'Up-Down axis: ' , Character cr asString , Character tab asString , 'Forward-Back axis: ']
		ifFalse: [nameMorph contents: 'Name: ' , anActor getName.
			(anActor isKindOf: WonderlandActor)
				ifTrue: [parentMorph contents: 'Parent: ' , anActor getParent getName.
					position _ anActor getPosition.
					position at: 1 put: ((position first * 1000) rounded / 1000.0) asString.
					position at: 2 put: ((position second * 1000) rounded / 1000.0) asString.
					position at: 3 put: ((position third * 1000) rounded / 1000.0) asString.
					positionMorph contents: Character tab asString , ('Right: ' , position first , '  Up: ' , position second , '  Forward: ' , position third).
					rotation _ anActor getAngles.
					rotation at: 1 put: ((rotation first * 1000) rounded / 1000.0) asString.
					rotation at: 2 put: ((rotation second * 1000) rounded / 1000.0) asString.
					rotation at: 3 put: ((rotation third * 1000) rounded / 1000.0) asString.
					rotationMorph contents: Character tab asString , 'Left-Right axis: ' , rotation first , Character cr asString , Character tab asString , 'Up-Down axis: ' , rotation second , Character cr asString , Character tab asString , 'Forward-Back axis: ' , rotation third]
				ifFalse: [parentMorph contents: 'Parent: None'.
					positionMorph contents: Character tab asString , 'Right:    Up:    Forward: '.
					rotationMorph contents: Character tab asString , 'Left-Right axis: ' , Character cr asString , Character tab asString , 'Up-Down axis: ' , Character cr asString , Character tab asString , 'Forward-Back axis: ']]! !


!WonderlandCameraMorph methodsFor: 'controls' stamp: 'dgd 2/22/2003 14:48'!
getCameraControls
	myControls isNil 
		ifTrue: 
			[self showCameraControls.
			self hideCameraControls].
	^myControls! !

!WonderlandCameraMorph methodsFor: 'dropping/grabbing' stamp: 'dgd 2/22/2003 14:49'!
wantsDroppedMorph: aMorph event: evt 
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a hand in response to the given event. The default implementation returns false.
NOTE: the event is assumed to be in global (world) coordinates."

	| pt |
	(super wantsDroppedMorph: aMorph event: evt) ifFalse: [^false].
	pt := self transformFromWorld globalPointToLocal: evt cursorPoint.
	(myCamera pickAt: pt) isNil ifTrue: [^false].
	^true! !

!WonderlandCameraMorph methodsFor: 'event handling' stamp: 'dgd 2/22/2003 14:48'!
mouseDown: evt 
	"When the user clicks in a camera window, determine which actor the    
	         user clicked on and have that actor respond to the event"

	| newEvent reactions |
	mode == #view ifTrue: [mode := nil].
	"ar 5/28/2001 - remove the above at some point; it's compensating for old wonderlands"
	self 
		on: #mouseMove
		send: #mouseMoveDefault:
		to: self.
	self 
		on: #mouseUp
		send: #mouseUpDefault:
		to: self.
	(evt redButtonPressed and: [evt anyModifierKeyPressed not]) 
		ifTrue: 
			[(mode isNil and: [firstPersonControls == true]) 
				ifTrue: 
					[self getCameraControls.	"create if necessary"
					myControls setCenter: evt position.
					myControls mouseDown: evt.
					evt hand needsToBeDrawn ifFalse: [Cursor crossHair show].
					self 
						on: #mouseMove
						send: #mouseMoveFirstPersonControl:
						to: self.
					self 
						on: #mouseUp
						send: #mouseUpFirstPersonControl:
						to: self.
					^self].
			mode == #stroke 
				ifTrue: 
					[self 
						on: #mouseMove
						send: #mouseMoveStroke:
						to: self.
					self 
						on: #mouseUp
						send: #mouseUpStroke:
						to: self.
					^self recordStroke: evt cursorPoint].
			newEvent := self convertEvent: evt.
			newEvent ifNil: [^self].
			mode == #paint 
				ifTrue: 
					[newEvent getVertex ifNil: [^self].
					self prepareAction: newEvent.
					self 
						on: #mouseMove
						send: #mouseMovePaint:
						to: self.
					self 
						on: #mouseUp
						send: #mouseUpPaint:
						to: self.
					^self perform: palette action with: newEvent]]
		ifFalse: 
			[newEvent := self convertEvent: evt.
			newEvent ifNil: [^self]].
	newEvent getActor hasActiveTexture 
		ifTrue: [^newEvent getActor morphicMouseDown: newEvent].
	(evt redButtonPressed or: [evt controlKeyPressed]) 
		ifTrue: 
			[reactions := newEvent getActor getReactionsTo: leftMouseDown.
			mouseUpButton := leftMouseUp]
		ifFalse: 
			[evt yellowButtonPressed 
				ifTrue: 
					[reactions := newEvent getActor getReactionsTo: rightMouseDown.
					mouseUpButton := rightMouseUp]
				ifFalse: [reactions := nil]].
	reactions 
		ifNotNil: [reactions do: [:aReaction | aReaction reactTo: newEvent]]! !

!WonderlandCameraMorph methodsFor: 'halos and balloon help' stamp: 'dgd 2/22/2003 14:48'!
addHalo: evt 
	"Add a halo to an object"

	| actor wrapper root |
	self removeAllWrappers.	"Get rid of them"
	evt isNil ifTrue: [^super addHalo: evt].
	actor := myCamera pickAt: evt cursorPoint.
	actor isNil ifTrue: [^super addHalo: evt].	"Nothing hit"
	wrapper := WonderlandWrapperMorph on: actor.
	root := wrapper createHierarchy.
	root computeFullBounds: self.
	self addMorphFront: root.
	"pass on the event as if it had been there"
	root processEvent: evt copy resetHandlerFields! !

!WonderlandCameraMorph methodsFor: 'layout' stamp: 'dgd 2/22/2003 14:48'!
acceptDroppingMorph: aMorph event: evt 
	"This message is sent when a morph is dropped onto a morph that has agreed to accept the dropped morph by responding 'true' to the wantsDroppedMorph:Event: message. This default implementation just adds the given morph to the receiver."

	| actor |
	actor := myCamera pickAt: evt cursorPoint.
	actor isNil ifTrue: [^self addMorphFront: aMorph].	"This should never happen."
	myWonderland getUndoStack 
		push: (UndoTextureChange for: actor from: actor getTexturePointer).
	aMorph installAsWonderlandTextureOn: actor.
	self world abandonAllHalos.
	"AAAARRRRGGGGGHHHH!!!!!!!!"
	aMorph owner ifNotNil: [aMorph owner privateRemoveMorph: aMorph].
	aMorph privateOwner: self.
	"Note: The above makes aMorph invisible to stupid HandMorph but keeps it in the world so it can continue stepping"
	actor adjustToTextureIfNecessary! !

!WonderlandCameraMorph methodsFor: 'menu' stamp: 'dgd 2/22/2003 14:49'!
toggleCameraControls
	myControls isNil 
		ifTrue: [self showCameraControls]
		ifFalse: [self deleteCameraControls]! !

!WonderlandCameraMorph methodsFor: 'pooh' stamp: 'gm 2/28/2003 00:38'!
createPoohActor
	| actor pointList box scale center subdivision mesh tex |
	pointList := self outline.
	pointList reset.
	pointList := pointList contents.
	pointList size < 2 
		ifTrue: 
			[self clearStroke.
			^errorSound play].
	pointList := self simplify: pointList.
	pointList := self smoothen: pointList length: 10.
	pointList := self regularize: pointList.
	box := Rectangle encompassing: pointList.
	scale := bounds extent y * 0.5.
	scale := 1.0 / (scale @ scale negated).
	center := (box origin + box corner) * 0.5.
	pointList := pointList collect: [:each | (each - center) * scale].
	subdivision := PoohSubdivision constraintOutline: pointList.
	mesh := subdivision build3DObject.
	mesh ifNil: [errorSound play]
		ifNotNil: 
			[actor := self getWonderland makeActorNamed: 'sketch'.
			actor
				setProperty: #handmade toValue: true;
				setBackfaceCulling: #ccw;
				setMesh: mesh;
				setColor: gray.
			tex := (Form extent: 256 @ (Preferences twoSidedPoohTextures 
						ifTrue: [512 ]
						ifFalse: [256 ]) depth: 32) asTexture fillColor: Color white
.
			actor setTexturePointer: tex.
			actor setComposite: (myCamera getMatrixFromRoot 
						composedWithLocal: (B3DMatrix4x4 withOffset: 0 @ 0 @ 2)).
			actor scaleByMatrix: (B3DRotation axis: 0 @ 1 @ 0 angle: 90) asMatrix4x4.
			actor rotateByMatrix: (B3DRotation axis: 0 @ 1 @ 0 angle: -90) asMatrix4x4].
	self clearStroke.
	self mode: nil.
	Cursor normal show! !

!WonderlandCameraMorph methodsFor: 'pooh' stamp: 'dgd 2/22/2003 14:49'!
regularize: pointCollection 
	"Make the pointList non-intersecting, e.g., insert points at intersections and have the outline include those points"

	| pointList segments last intersections map pts |
	pointList := pointCollection collect: [:pt | pt asIntegerPoint].
	segments := WriteStream on: (Array new: pointList size).
	last := pointList last.
	pointList do: 
			[:next | 
			segments nextPut: (LineSegment from: last to: next).
			last := next].
	segments := segments contents.
	intersections := LineIntersections of: segments.
	map := IdentityDictionary new: segments size.
	intersections do: 
			[:is | 
			(map at: is second ifAbsentPut: [WriteStream on: (Array new: 2)]) 
				nextPut: is first.
			(map at: is third ifAbsentPut: [WriteStream on: (Array new: 2)]) 
				nextPut: is first].
	pts := WriteStream on: (Array new: pointList size).
	segments do: 
			[:seg | 
			intersections := (map at: seg) contents.
			intersections := intersections 
						sort: [:p1 :p2 | (p1 squaredDistanceTo: seg start) <= (p2 squaredDistanceTo: seg start)].
			last := intersections first.
			pts nextPut: last.
			intersections do: 
					[:next | 
					(next = last and: [next = seg end]) 
						ifFalse: 
							[pts nextPut: next.
							last := next]]].
	^pts contents! !

!WonderlandCameraMorph methodsFor: 'pooh' stamp: 'jdl 3/28/2003 09:39'!
smoothen: pointList length: unitLength 
	| prevPt curPt nextPt out prevMid nextMid segment length steps deltaT |
	out := WriteStream on: (Array new: pointList size).
	prevPt := pointList at: pointList size - 1.
	curPt := pointList last.
	prevMid := (curPt + prevPt) * 0.5.
	1 to: pointList size
		do: 
			[:i | 
			nextPt := pointList at: i.
			nextMid := (nextPt + curPt) * 0.5.
			segment := Bezier2Segment 
						from: prevMid
						to: nextMid
						via: curPt.
			length := segment length.
			steps := (length / unitLength) asInteger.
			steps := steps max: 1.
			deltaT := 1.0 / steps.
			1 to: steps - 1 do: [:k | out nextPut: (segment valueAt: deltaT * k)].
			out nextPut: nextMid.
			prevPt := curPt.
			curPt := nextPt.
			prevMid := nextMid].
	^out contents! !

!WonderlandCameraMorph methodsFor: 'pooh-actions' stamp: 'dgd 2/22/2003 14:49'!
paint: newEvent 
	| bb newPosition dx firstY lastY dy py midX |
	newPosition := newEvent getVertex texCoords * currentCanvas extent 
				- (currentNib extent // 2).
	"Watch out for wrapping in y"
	(newPosition y - currentPosition y) abs > (currentCanvas form height // 2) 
		ifTrue: 
			["Go the other (shorter) way around"

			dx := newPosition x - currentPosition x.
			newPosition y > currentPosition y 
				ifTrue: 
					[firstY := 0.
					lastY := currentCanvas form height.
					dy := currentCanvas form height - newPosition y + currentPosition y.
					py := currentPosition y]
				ifFalse: 
					[firstY := currentCanvas form height.
					lastY := 0.
					dy := currentCanvas form height - currentPosition y + newPosition y.
					py := currentCanvas form height - currentPosition y].
			midX := currentPosition x + (dx * (py / dy)).
			midX := midX asInteger].
	bb := BitBlt toForm: currentCanvas form.
	bb
		sourceForm: currentNib;
		sourceRect: currentNib boundingBox;
		colorMap: (currentNib colormapIfNeededFor: bb destForm);
		combinationRule: Form blend.
	midX isNil 
		ifTrue: 
			[bb drawFrom: currentPosition asIntegerPoint to: newPosition asIntegerPoint]
		ifFalse: 
			[bb
				drawFrom: currentPosition asIntegerPoint to: midX @ firstY;
				drawFrom: midX @ lastY to: newPosition asIntegerPoint].
	currentPosition := newPosition! !


!WonderlandWrapperMorph methodsFor: 'accessing' stamp: 'dgd 2/21/2003 22:55'!
getCameraMorph
	| morph |
	morph := owner.
	[morph isNil] whileFalse: 
			[(morph isKindOf: WonderlandCameraMorph) ifTrue: [^morph].
			morph := morph owner].
	^nil! !

!WonderlandWrapperMorph methodsFor: 'drawing' stamp: 'dgd 2/21/2003 22:55'!
drawOn: aCanvas 
	| morph |
	morph := self getCameraMorph.
	morph isNil
		ifTrue: [super drawOn: aCanvas]
		ifFalse: 
			[self computeBounds: morph.	"Update bounds from camera"
			false 
				ifTrue: 
					["Show a rectangle for the wrappers"

					aCanvas frameRectangle: bounds color: Color white]]! !

!WonderlandWrapperMorph methodsFor: 'halos and balloon help' stamp: 'dgd 2/21/2003 22:54'!
addHandlesTo: aHaloMorph box: box 
	| dismissHandle s |
	s := aHaloMorph handleSize.
	myActor getTexturePointer isNil 
		ifFalse: 
			[aHaloMorph 
				addHandleAt: box rightCenter
				color: Color lightGray
				on: #mouseDown
				send: #extractTexture:
				to: aHaloMorph target].
	aHaloMorph 
		addHandleAt: box topLeft
		color: Color red
		icon: 'Halo-Menu'
		on: #mouseDown
		send: #doMenu:with:
		to: aHaloMorph.
	aHaloMorph 
		addHandleAt: (box leftCenter + (0 @ (s + 2)) 
				min: (box leftCenter + box bottomLeft) // 2)
		color: Color lightBrown
		icon: 'Halo-Tile'
		on: #mouseDown
		send: #tearOffTile
		to: self.
	dismissHandle := aHaloMorph 
				addHandleAt: (box topLeft + ((s + 2) @ 0) 
						min: (box topLeft + box topCenter) // 2)
				color: Color red muchLighter
				icon: 'Halo-Dismiss'
				on: #mouseDown
				send: #mouseDownInDimissHandle:with:
				to: aHaloMorph.
	dismissHandle 
		on: #mouseUp
		send: #maybeDismiss:with:
		to: aHaloMorph.
	dismissHandle 
		on: #mouseDown
		send: #setDismissColor:with:
		to: aHaloMorph.
	dismissHandle 
		on: #mouseMove
		send: #setDismissColor:with:
		to: aHaloMorph.
	aHaloMorph 
		addHandleAt: box leftCenter
		color: Color cyan
		icon: 'Halo-View'
		on: #mouseDown
		send: #openViewerForArgument
		to: self.
	aHaloMorph 
		addHandleAt: box topCenter
		color: Color black
		icon: 'Halo-Grab'
		on: #mouseDown
		send: #grabFromHalo:with:
		to: self.
	(aHaloMorph 
		addHandleAt: (box topCenter + ((s + 2) @ 0) 
				min: (box topCenter + box topRight) // 2)
		color: Color brown
		icon: 'Halo-Drag'
		on: #mouseDown
		send: #dragStartFromHalo:with:
		to: self)
		on: #mouseMove
			send: #dragMoveFromHalo:with:
			to: self;
		on: #mouseUp
			send: #dragEndFromHalo:with:
			to: self.
	(aHaloMorph 
		addHandleAt: box topRight
		color: Color green
		icon: 'Halo-Dup'
		on: #mouseDown
		send: #dupStartFromHalo:with:
		to: self)
		on: #mouseMove
			send: #dupMoveFromHalo:with:
			to: self;
		on: #mouseUp
			send: #dupEndFromHalo:with:
			to: self.
	Preferences showDebugHaloHandle 
		ifTrue: 
			[aHaloMorph 
				addHandleAt: (box topRight + box rightCenter) // 2
				color: Color blue veryMuchLighter
				icon: 'Halo-Debug'
				on: #mouseDown
				send: #doDebug:with:
				to: aHaloMorph].
	(aHaloMorph 
		addHandleAt: box bottomLeft
		color: Color blue
		icon: 'Halo-Rotate'
		on: #mouseDown
		send: #rotateStartFromHalo:with:
		to: self)
		on: #mouseMove
			send: #rotateMoveFromHalo:with:
			to: self;
		on: #mouseUp
			send: #rotateEndFromHalo:with:
			to: self.
	(aHaloMorph 
		addHandleAt: box bottomRight
		color: Color yellow
		icon: 'Halo-Scale'
		on: #mouseDown
		send: #growStartFromHalo:with:
		to: self)
		on: #mouseMove
			send: #growMoveFromHalo:with:
			to: self;
		on: #mouseUp
			send: #growEndFromHalo:with:
			to: self.
	myActor isHandmade 
		ifTrue: 
			[aHaloMorph 
				addHandleAt: box center
				color: Color white
				icon: 'Halo-Paint'
				on: #mouseUp
				send: #paintTexture
				to: self]! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'dgd 2/21/2003 22:55'!
dragMoveFromHalo: evt with: handle 
	| morph delta screenPos scenePos |
	morph := self getCameraMorph.
	morph isNil ifTrue: [^self].
	delta := (self pointFromWorld: evt cursorPoint - self dragPositionOffset) 
				- self position.
	screenPos := (myActor getPositionInPixels: morph getCamera) + delta.
	scenePos := morph getCamera transformScreenPointToScenePoint: screenPos
				atDepthOf: myActor.
	myActor 
		moveToRightNow: scenePos
		asSeenBy: myWonderland getScene
		undoable: false! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'dgd 2/21/2003 22:55'!
dragPositionOffset: aPoint 
	aPoint isNil 
		ifTrue: [self removeProperty: #dragPositionOffset]
		ifFalse: [self setProperty: #dragPositionOffset toValue: aPoint]! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'gm 2/27/2003 23:49'!
growMoveFromHalo: evt with: handle 
	| newExtent scale |
	newExtent := (self 
				pointFromWorld: evt cursorPoint - self growPositionOffset) - self topLeft.
	newExtent := newExtent max: 1 @ 1.
	scale := newExtent r / bounds extent r.
	scale := B3DVector3 
						x: scale
						y: scale
						z:(evt shiftPressed 
		ifTrue: 
			[ 1.0]
		ifFalse: 
			[scale]).
	myActor resizeRightNow: scale undoable: false.
	handle position: evt cursorPoint - (handle extent // 2)! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'dgd 2/21/2003 22:55'!
growPositionOffset: aPoint 
	aPoint isNil
		ifTrue: [self removeProperty: #growPositionOffset]
		ifFalse: [self setProperty: #growPositionOffset toValue: aPoint]! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'dgd 2/21/2003 22:56'!
removeAllHandlesBut: aHandle 
	| halo |
	halo := self halo.
	halo isNil ifFalse: [halo removeAllHandlesBut: aHandle]! !

!WonderlandWrapperMorph methodsFor: 'menu' stamp: 'dgd 2/21/2003 22:56'!
setUserPointOfView
	| morph |
	morph := self getCameraMorph.
	morph isNil ifTrue: [^self].
	myActor setUserPointOfView: (morph getCamera getPointOfView: myActor)! !

!WonderlandWrapperMorph methodsFor: 'private' stamp: 'dgd 2/21/2003 22:55'!
computeBounds: morph 
	| box |
	box := myActor getFullBoundsFor: morph getCamera.
	box isNil ifFalse: [bounds := box]! !


!WordGameLetterMorph methodsFor: 'accessing' stamp: 'dgd 2/21/2003 23:15'!
isBlank
	^indexInQuote isNil! !

!WordGameLetterMorph methodsFor: 'initialization' stamp: 'dgd 2/21/2003 23:15'!
indexInQuote: qi id1: aString 
	"Initialize me with the given index and an optional aString"
	| idMorph y |
	style = #boxed
		ifTrue: [aString isNil
				ifTrue: [self extent: 18 @ 16;
						 borderWidth: 1]
				ifFalse: [self extent: 26 @ 24;
						 borderWidth: 1]]
		ifFalse: [aString isNil
				ifTrue: [self extent: 18 @ 16;
						 borderWidth: 0]
				ifFalse: [self extent: 18 @ 26;
						 borderWidth: 0]].
	qi
		ifNil: [^ self color: Color gray].
	"blank"
	self color: self normalColor.
	indexInQuote _ qi.
	style == #underlined
		ifTrue: [y _ self bottom - 2.
			aString
				ifNotNil: [y _ y - IDFont ascent + 2].
			lineMorph _ PolygonMorph
						vertices: {self left + 2 @ y. self right - 3 @ y}
						color: Color gray
						borderWidth: 1
						borderColor: Color gray.
			self addMorph: lineMorph.
			aString
				ifNil: [^ self].
			idMorph _ StringMorph contents: aString font: IDFont.
			idMorph align: idMorph bounds bottomCenter with: self bounds bottomCenter + (0 @ (IDFont descent - 1)).
			self addMorphBack: idMorph]
		ifFalse: [aString
				ifNil: [^ self].
			idMorph _ StringMorph contents: aString font: IDFont.
			idMorph align: idMorph bounds topLeft with: self bounds topLeft + (2 @ -1).
			self addMorph: idMorph
			" 
			World addMorph: (WordGameLetterMorph new boxed  
			indexInQuote: 123 id1: '123';  
			id2: 'H'; setLetter: $W).  
			World addMorph: (WordGameLetterMorph new underlined  
			indexInQuote: 123 id1: '123';  
			setLetter: $W).  
			World addMorph: (WordGameLetterMorph new underlined  
			indexInQuote: 123 id1: nil;  
			setLetter: $W). 
			"]! !

!WordGameLetterMorph methodsFor: 'initialization' stamp: 'dgd 2/21/2003 23:15'!
setLetter: aLetter color: aColor 
	letterMorph ifNotNil: [letterMorph delete].
	letter := aLetter.
	letter ifNil: [^letterMorph := nil].
	letterMorph := StringMorph contents: aLetter asString font: LetterFont.
	letterMorph color: aColor.
	style == #boxed 
		ifTrue: 
			[letterMorph align: letterMorph bounds bottomCenter
				with: self bounds bottomCenter + (0 @ (LetterFont descent - 2))]
		ifFalse: 
			[lineMorph isNil 
				ifTrue: 
					[letterMorph align: letterMorph bounds bottomCenter
						with: self bounds bottomCenter + (0 @ (LetterFont descent - 4))]
				ifFalse: 
					[letterMorph align: letterMorph bounds bottomCenter
						with: self center x @ (lineMorph top + LetterFont descent)]].
	self addMorphBack: letterMorph! !

!WordGameLetterMorph methodsFor: 'linking' stamp: 'dgd 2/21/2003 23:15'!
morphsInWordDo: aBlock 
	aBlock value: self.
	(successor isNil or: [successor isBlank]) ifTrue: [^self].
	successor morphsInWordDo: aBlock! !

!WordGameLetterMorph methodsFor: 'linking' stamp: 'dgd 2/21/2003 23:15'!
startOfWord
	(predecessor isNil or: [predecessor isBlank]) ifTrue: [^self].
	^predecessor startOfWord! !


!WordGamePanelMorph methodsFor: 'events' stamp: 'aoy 2/15/2003 21:25'!
keyStrokeEvent: evt letterMorph: morph 
	"Handle typing.  Calls keyCharacter:atIndex:nextFocus: for further behavior."

	| affectedMorph keyCharacter nextFocus |
	evt keyCharacter = Character backspace 
		ifTrue: 
			["<delete> zaps the current selection if there has been no typing,
				but it zaps the previous selection if there has been prior typing."

			affectedMorph := haveTypedHere 
						ifTrue: [morph previousTypeableLetter]
						ifFalse: [morph]. 
			keyCharacter := Character space.
			nextFocus := morph previousTypeableLetter]
		ifFalse: 
			[affectedMorph := morph.
			keyCharacter := evt keyCharacter asUppercase.
			(keyCharacter isLetter or: [keyCharacter = Character space]) 
				ifFalse: [^self].
			haveTypedHere := true.
			nextFocus := morph nextTypeableLetter.
			nextFocus == morph 
				ifTrue: 
					["If hit end of a word, change backspace mode"

					haveTypedHere := false]].
	evt hand newKeyboardFocus: nextFocus.
	self unhighlight.
	nextFocus color: Color green.
	self 
		keyCharacter: keyCharacter
		atIndex: affectedMorph indexInQuote
		nextFocus: nextFocus! !


!CipherPanel methodsFor: 'initialization' stamp: 'dgd 2/22/2003 13:36'!
encodedQuote: aString 
	"World addMorph: CipherPanel new"

	| morph prev |
	aString isEmpty ifTrue: [^self].
	(letterMorphs isNil or: [self isClean]) 
		ifFalse: 
			[(self confirm: 'Are you sure you want to discard all typing?') 
				ifFalse: [^self]].
	haveTypedHere := false.
	quote := aString asUppercase.
	prev := nil.
	originalMorphs := quote asArray collectWithIndex: 
					[:c :i | 
					(WordGameLetterMorph new plain)
						indexInQuote: i id1: nil;
						setLetter: (quote at: i)].
	letterMorphs := OrderedCollection new.
	decodingMorphs := quote asArray collectWithIndex: 
					[:c :i | 
					(quote at: i) isLetter 
						ifTrue: 
							[morph := WordGameLetterMorph new underlined indexInQuote: i id1: nil.
							morph 
								on: #mouseDown
								send: #mouseDownEvent:letterMorph:
								to: self.
							morph 
								on: #keyStroke
								send: #keyStrokeEvent:letterMorph:
								to: self.
							letterMorphs addLast: morph.
							morph predecessor: prev.
							prev ifNotNil: [prev successor: morph].
							prev := morph]
						ifFalse: 
							[(WordGameLetterMorph new plain)
								indexInQuote: i id1: nil;
								setLetter: (quote at: i)]].
	self color: originalMorphs first color.
	self extent: 500 @ 500! !


!CrosticQuotePanel class reorganize!
('no messages')
!


!CrosticPanel class reorganize!
('as yet unclassified' newFromFile: oldStyle sampleFile)
('instance creation' new)
('new-morph participation' includeInNewMorphMenu)
('parts bin' descriptionForPartsBin)
!


!CipherPanel class reorganize!
('as yet unclassified' encode: newFromQuote: randomComment sampleString tedsHack)
('instance creation' new)
('new-morph participation' includeInNewMorphMenu)
('parts bin' descriptionForPartsBin)
!


!WordGamePanelMorph class reorganize!
('new-morph participation' includeInNewMorphMenu)
!


!CrosticQuotePanel reorganize!
('defaults' highlight: keyCharacter:atIndex:nextFocus: lostFocus)
('geometry' extent:)
('initialization' quote:answers:cluesPanel:)
!


!CrosticPanel reorganize!
('defaults' clearTyping highlight: keyCharacter:atIndex:nextFocus: lostFocus)
('initialization' breakColumnAndResizeWithButtons: quote:clues:answers:quotePanel:)
('menu' addMenuItemsTo:hand: buttonRow openFile showErrors showHelpWindow showHintsWindow)
('parts bin' initializeToStandAlone)
!


!CipherPanel reorganize!
('defaults' clearTyping keyCharacter:atIndex:nextFocus:)
('geometry' extent:)
('initialization' encodedQuote:)
('menu' addMenuItemsTo:hand: buttonRow cipherStats enterANewCipher showHelpWindow showHintsWindow squeakCipher)
('parts bin' initializeToStandAlone)
!


!WordGamePanelMorph reorganize!
('access' letterMorphs)
('defaults' clearTyping highlight: isClean keyCharacter:atIndex:nextFocus: lostFocus unhighlight)
('event handling' handlesMouseDown:)
('events' checkForLostFocus keyStrokeEvent:letterMorph: mouseDownEvent:letterMorph:)
('menu' addMenuItemsTo:hand:)
('menus' addCustomMenuItems:hand:)
!


!WordGameLetterMorph class reorganize!
('class initialization' initialize)
('new-morph participation' includeInNewMorphMenu)
!


!WordGameLetterMorph reorganize!
('accessing' indexInQuote isBlank letter predecessor predecessor: successor successor:)
('event handling' handlesKeyboard: keyboardFocusChange:)
('initialization' id2: indexInQuote:id1: normalColor setLetter: setLetter:color:)
('linking' morphsInWordDo: nextTypeableLetter previousTypeableLetter startOfWord)
('style inits' boxed plain underlined)
('typing' unhighlight)
!


!WonderlandWrapperMorph class reorganize!
('instance creation' on:)
!


!WonderlandWrapperMorph reorganize!
('accessing' color color: getCameraMorph)
('drawing' drawOn: fullDrawOn:)
('halos and balloon help' addHandlesTo:box: addSimpleHandlesTo:box: balloonHelpTextForHandle: hasHalo: transferHalo:from:)
('handles' dragEndFromHalo:with: dragMoveFromHalo:with: dragPositionOffset dragPositionOffset: dragStartFromHalo:with: dupEndFromHalo:with: dupMoveFromHalo:with: dupStartFromHalo:with: extractTexture: grabFromHalo:with: growEndFromHalo:with: growMoveFromHalo:with: growPositionOffset growPositionOffset: growStartFromHalo:with: removeAllHandlesBut: rotateEndFromHalo:with: rotateMoveFromHalo:with: rotateStartFromHalo:with:)
('initialization' createHierarchy setActor:)
('menu' getActiveTextureState getHQTextureState getTextureAdjust paintTexture setUserPointOfView toggleActiveTextureState toggleHQTextureState toggleTextureAdjust)
('menus' addCustomMenuItems:hand:)
('player viewer' openViewerForArgument)
('scripting' tearOffTile)
('submorphs-add/remove' dismissViaHalo)
('testing' knownName renameTo:)
('private' computeBounds: computeFullBounds: undo:using: undoOnTop:using:)
!


!WonderlandStillCameraMorph class reorganize!
('no messages')
!


!WonderlandStillCameraMorph reorganize!
('controls' hideCameraControls showCameraControls)
('event handling' handlesMouseDown: handlesMouseOver:)
('testing' wantsSteps)
!


!WonderlandEditor class reorganize!
('instance creation' newFor:)
!


!WonderlandControls class reorganize!
('instance creation' newFor:)
!


!WonderlandCameraMorph class reorganize!
('class initialization' initialize)
('pooh stuff' installPoohIcon openPoohAboutWindow poohAboutImage poohAboutText poohPlayTape poohTape)
('scripting' additionsToViewerCategories)
!


!WonderlandActorData class reorganize!
('no messages')
!


!WonderlandMorph class reorganize!
('no messages')
!


!WonderlandEditor reorganize!
('accessing' resetNamespace updateActorBrowser)
('geometry' extent:)
('initialization' initializeWith:)
!


!WonderlandControls reorganize!
('actions' quitWonderland)
('initialization' initializeWith:)
('stepping and presenter' step)
('testing' stepTime wantsSteps)
!


!WonderlandCameraMorph reorganize!
('accessing' getCamera mode mode: outline outline:)
('controls' deleteCameraControls getCameraControls hideCameraControls showCameraControls)
('debug' debugDraw)
('drawing' areasRemainingToFill: drawAcceleratedOn: drawAcceleratedOutlineOn: drawOn: drawSimulatedOn: forceToScreen renderOn: sketchOn:)
('dropping/grabbing' wantsDroppedMorph:event:)
('event handling' convertEvent: doFirstPersonControl doFirstPersonControl: firstPersonKeystroke: firstPersonMouseUp: getEventFocus handlesKeyboard: handlesMouseDown: handlesMouseOver: keyStroke: mouseDown: mouseEnter: mouseLeave: mouseMoveDefault: mouseMoveFirstPersonControl: mouseMovePaint: mouseMoveStroke: mouseUpDefault: mouseUpFirstPersonControl: mouseUpPaint: mouseUpStroke: setEventFocus:)
('events-processing' containsPoint:event: handleMouseDown:)
('fog properties' fogColor fogColor: fogDensity fogDensity: fogRangeEnd fogRangeEnd: fogRangeStart fogRangeStart: fogType fogType:)
('geometry testing' containsPoint:)
('halos and balloon help' addHalo: addHalo:from: balloonHelpTextForHandle:)
('hardware acceleration' accelerationEnabled accelerationEnabled: accelerationSuspended accelerationSuspended: restoreAcceleration suspendAcceleration)
('initialization' initialize initializeWithCamera: intoWorld: okayToEnterProject outOfWorld:)
('layout' acceptDroppingMorph:event: layoutChanged)
('menu' attachStopGoButtons firstPersonControlString getAAPaintState getAcceleratorState loadActor showControlsString toggleAAPaintState toggleAcceleratorState toggleCameraControls toggleFirstPersonControl)
('menus' addCustomMenuItems:hand:)
('picking points' pickPointInBounds: pickPointOnBounds:)
('pooh' clearStroke createPoohActor drawOnTextureOf:from:to: paintActor: recordStroke: regularize: simplify: smoothen:length: strokeMode)
('pooh-actions' aaPaintingEnabled aaPaintingEnabled: clear: ellipse: erase: fill: line: mouseDownEllipse: mouseDownLine: mouseDownRect: mouseMoveEllipse: mouseMoveLine: mouseMoveRect: mouseUpEllipse: mouseUpLine: mouseUpRect: paint: polygon: prepareAction: rect: restoreTexture restoreTextureFrom: roundNibOfSize: stamp: star: storeTexture)
('pooh-palette' cancel cancelPainting:evt: clear clearPainting: paletteAttached: paletteDetached: save savePainting:evt: undo undoPainting:evt:)
('stepping and presenter' step)
('testing' stepTime wantsSteps)
('wrappers' removeAllWrappers)
!


!WonderlandActorData reorganize!
('initialization' defaultBounds defaultColor initialize)
('setting actor' setActor:)
!


!WonderlandMorph reorganize!
('accessing' getWonderland setWonderland:)
('morph depth' sendBehind: sendInFrontOf: sendToBack sendToFront)
('primitive behaviors' move:distance: move:distance:duration: move:distance:duration:style: moveTo: moveTo:duration: moveTo:duration:style: moveTo:speed: place:morph: place:morph:duration: place:morph:duration:style:)
!


!WonderlandEditorTabs class reorganize!
('instance creation' newFor:)
!


!WonderlandEditorTabs reorganize!
('accessing' getActorViewer resetNamespace)
('geometry' extent:)
('initialization' addPanel: initializeWith:)
('user-interface' selectTab:)
!


!WonderlandCameraControls class reorganize!
('instance creation' newFor:)
!


!WonderlandCameraControls reorganize!
('accessing' getCenter setCenter:)
('camera control' moveCamera:)
('event handling' handlesMouseDown: mouseDown: mouseUp:)
('geometry' extent:)
('initialization' initializeWith:)
('properties' getMoveScale getRotationScale setMoveScale: setRotationScale:)
!


!WonderlandActorViewer class reorganize!
('no messages')
!


!WonderlandActorViewer reorganize!
('initialization' defaultColor initialize initializeWith:)
('stepping and presenter' step)
('testing' stepTime wantsSteps)
('updating' setSelectedActor: turnUpdatingOff turnUpdatingOn)
!


!WheelMorph class reorganize!
('examples' example)
!


!WheelMorph reorganize!
('accessing' actionSelector actionSelector: angle angle: factor factor: maxAngle maxAngle: target target:)
('drawing' drawOn:)
('event handling' doTargetAction: handlesMouseDown: mouseDown: mouseMove:)
('initialization' defaultBorderColor defaultBorderWidth defaultColor initialize)
('properties' beCircular beHorizontal beLinear beVertical isCircular isHorizontal isLinear isVertical)
('private' addAngle:)
!


!TetrisBoard class reorganize!
('new-morph participation' includeInNewMorphMenu)
!

TetrisBoard removeSelector: #initialize!

!TetrisBoard reorganize!
('accessing' game: score:)
('as yet unclassified' cellSize originForCell:)
('button actions' dropAllTheWay moveLeft moveRight newGame pause rotateAntiClockWise rotateClockWise running)
('data' emptyAt: numColumns numRows)
('initialization' defaultBounds defaultColor)
('other' checkForFullRows storePieceOnBoard)
('stepping and presenter' step)
('testing' stepTime)
!


!TetrisBlock class reorganize!
('as yet unclassified' flipShapes: shapeChoices)
('new-morph participation' includeInNewMorphMenu)
!


!TetrisBlock reorganize!
('as yet unclassified' board: dropByOne moveDeltaX:deltaY:deltaAngle: positionCellMorphs)
('initialization' defaultBounds defaultColor initialize)
!


!Tetris class reorganize!
('as yet unclassified' colors)
('parts bin' descriptionForPartsBin)
!


!Tetris reorganize!
('event handling' handlesKeyboard: handlesMouseOver: keyStroke: mouseEnter:)
('events' score:)
('initialization' buildButtonTarget:label:selector:help: defaultColor initialize makeGameControls makeMovementControls rowForButtons showScoreDisplay wrapPanel:label:)
!


!TestRunner class reorganize!
('class initialization' initialize)
('instance creation' new open testRunnerUsage)
('new-morph participation')
('parts bin')
('processing' runTests)
!


!TestRunner reorganize!
('accessing' details errors failures formatTime: passFail suite tests timeSinceLastPassAsString:)
('constants' debugButtonLabel debugState errorColor failColor passColor refreshButtonLabel refreshButtonState resetColor runButtonColor runButtonLabel runButtonState runOneButtonLabel windowLabel)
('creation' openAsMorph)
('initialization' initialize)
('initialize' gatherTestNames)
('interface opening')
('menus')
('message handling')
('processing' debugErrorTest: debugFailureTest: debugTest refreshTests runOneTest runTests selectedErrorTest selectedFailureTest selectedSuite selectedSuite:)
('recording')
('test processing' showResult showResultDefects showResultSummary)
('updating' displayDetails: displayErrors: displayFailures: displayPassFail: refreshWindow runWindow updateDetails: updateErrors: updateFailures: updatePartColors: updatePassFail: updateWindow:)
('user interface')
!


!TestBalloonFont class reorganize!
('no messages')
!


!TestBalloonFont reorganize!
('tests' testDefaultFont testSpecificFont)
!


!SameGameTile class reorganize!
('new-morph participation' includeInNewMorphMenu)
!


!SameGameTile reorganize!
('accessing' color: disabled disabled: insetColor setSwitchState: switchState)
('button' doButtonAction)
('event handling' mouseDown: mouseMove: mouseUp:)
('initialization' initialize)
!


!SameGameBoard class reorganize!
('new-morph participation' includeInNewMorphMenu)
!

SameGameBoard removeSelector: #defaultBorderColor!

!SameGameBoard reorganize!
('accessing' actionSelector actionSelector: columns columns: columns:rows: protoTile protoTile: rows rows: selectionCount target target: tileAt:)
('actions' collapseColumn:fromRow: collapseColumns: deselectSelection findSelection hint removeColumn: removeSelection selectTilesAdjacentTo: tileClickedAt:newSelection:)
('geometry' extent:)
('initialization' defaultBorderWidth defaultColor initialize resetBoard)
('layout' acceptDroppingMorph:event:)
('preferences' preferredColumns preferredRows preferredTileTypes)
('stepping and presenter' step)
('testing' stepTime)
('undo' capturedState undoFromCapturedState:)
('private' adjustTiles tilesRemaining)
!


!SameGame class reorganize!
('parts bin' descriptionForPartsBin)
!


!SameGame reorganize!
('access' board board: helpString helpText scoreDisplay)
('actions' help: newGame selection)
('initialization' buildButton:target:label:selector: defaultColor initialize makeControls wrapPanel:label:)
!


!PoohTestMorph class reorganize!
('parts bin' descriptionForPartsBin)
!


!PoohTestMorph reorganize!
('drawing' drawOn: drawSubdivisionEdgesOn: drawSubdivisionSpineOn: drawSubdivisionTrianglesOn:)
('event handling' handlesMouseDown: mouseDown: mouseMove: mouseUp: regularize: simplify: smoothen:length: subdivide triangulate)
('initialization' defaultColor initialize)
!


!PlayingCardMorph class reorganize!
('access' cardSize height suits width)
('initialize-release' the:of:)
('new-morph participation' includeInNewMorphMenu)
('testing' test)
!


!PlayingCardMorph reorganize!
('access' board cardDeck cardNumber cardNumber:suitNumber: suit suitColor suitNumber)
('dropping/grabbing' aboutToBeGrabbedBy: justDroppedInto:event: slideBackToFormerSituation:)
('event handling' click: doubleClick: firstClickTimedOut: handlesMouseDown: mouseDown:)
('printing' printOn:)
!


!PlayingCardDeck class reorganize!
('instance creation' newDeck newSuit:)
('new-morph participation' includeInNewMorphMenu)
('symbols' suits values)
!


!PlayingCardDeck reorganize!
('accessing' acceptCardSelector: addCard: cardDoubleClickSelector: cardDraggedSelector: cardDroppedSelector: cards emptyDropPolicy: hasCards layout: newSeed removeAllCards seed seed: stackingOrder: stackingPolicy stackingPolicy: subDeckStartingAt: target: topCard)
('dropping/grabbing' acceptCard:default: emptyDropNotOk: emptyDropOk: ifEmpty: ifEmpty:ifNotEmpty: inStackingOrder: inStackingOrder:event: inStackingOrder:onTopOf: insertionIndexFor: repelCard: repelCard:default: repelsMorph:event: rootForGrabOf:)
('events' doubleClickOnCard:)
('initialization' initialize newDeck newSuit:)
('layout' acceptDroppingMorph:event: staggerOffset)
('printing' printOn:)
('shuffling/dealing' deal deal: reverse shuffle)
('private' nilOrSymbol:)
!


!PlayingCard class reorganize!
('all' imageData includeInNewMorphMenu test the:of:)
('class initialization' initialize)
!


!PlayingCard reorganize!
('all' blankCard buildImage cardForm color copyTopToBottomHalf faceColorMap setCardNo:suitNo:cardForm:)
!


!MinesTile class reorganize!
('new-morph participation' includeInNewMorphMenu)
!


!MinesTile reorganize!
('accessing' color: disabled disabled: doButtonAction: isMine isMine: mineFlag mineFlag: nearMines nearMines: switchState switchState:)
('drawing' drawOn:)
('event handling' mouseDown: mouseMove: mouseUp:)
('initialization' initialize preferredColor)
!


!MinesBoard class reorganize!
('new-morph participation' includeInNewMorphMenu)
!


!MinesBoard reorganize!
('accessing' actionSelector actionSelector: adjustTiles protoTile protoTile: target target: tileAt:)
('actions' blowUp clearMines: countFlags: findMines: selectTilesAdjacentTo: stepOnTile: tileClickedAt:newSelection:modifier:)
('geometry' extent:)
('initialization' defaultBorderColor defaultBorderWidth defaultColor initialize resetBoard setMines:)
('preferences' preferredColumns preferredMines preferredRows)
('stepping and presenter' step)
('testing' stepTime)
!


!Mines class reorganize!
('parts bin' descriptionForPartsBin)
!


!Mines reorganize!
('access' board helpString helpText minesDisplay timeDisplay)
('actions' help: newGame)
('initialization' defaultBorderColor defaultBorderWidth defaultColor initialize)
('initialize' buildButton:target:label:selector: makeControls wrapPanel:label:)
!


!InterpolatingImageMorph class reorganize!
('no messages')
!


!InterpolatingImageMorph reorganize!
('accessing' image:)
('drawing' cachedImageForDepth: drawImage:on: drawOn:)
('geometry' extent:)
!


!FreeCellStatistics class reorganize!
('instance creation' includeInNewMorphMenu new)
!


!FreeCellStatistics reorganize!
('actions' gameLost: gameWon: newSession ok reset updateStreak)
('initialization' initialize)
('printing' print:type:on: printOn: printReplaysOn: printSessionOn: printStreaksOn: printTotalOn:)
('updating' changed)
('user interface' buildButton:target:label:selector: close color display makeControls makeOkButton makeResetButton makeStatistics statsText stringMorphFromPrintOn:)
!


!FreeCellBoard class reorganize!
('new-morph participation' includeInNewMorphMenu)
!

FreeCellBoard removeSelector: #defaultBorderWidth!

!FreeCellBoard reorganize!
('accessing' actionSelector: cardDeck hardness hardness: target:)
('actions' acceptCard:onStack: acceptSingleCard:on: cardMoved cardMovedHome doubleClickInStack:OnCard: dragCard:fromHome: dragCard:fromStack: inAutoMove)
('card in a stack' stack)
('drawing' drawOn:)
('hardness' addHardness makeHarder:rand:toDo:)
('initialization' defaultColor initialize pickGame: resetBoard resetFreeCells resetHomeCells resetStacks)
('layout' cardCell cellsRow cellsRowSpacer freeCell freeCells homeCell homeCells layout stacks stacksRow)
('undo' captureStateBeforeGrab capturedState rememberUndoableAction:named: undoFromCapturedState:)
('private' autoMoveCardsHome isPlayableCardInHomeCells: maxDraggableStackSize: performActionSelector: visiblyMove:to:)
!


!FreeCell class reorganize!
('class initialization' initialize)
('parts bin' descriptionForPartsBin)
!


!FreeCell reorganize!
('accessing' board currentGame helpText)
('actions' autoMovingHome boardAction: cardMovedHome gameLost gameWon help inAutoMove newGame newGameNumber: pickGame promptForSeed quit sameGame statistics)
('initialization' defaultBorderWidth defaultColor initialize makeCardsRemainingDisplay makeControlBar makeControls makeElapsedTimeDisplay makeGameNumberDisplay makeHelpButton makeNewGameButton makePickGameButton makeQuitButton makeSameGameButton makeStatisticsButton openInWindowLabeled:inWorld:)
('user interface' defaultBackgroundColor modelSleep modelWakeUp)
('visual properties' colorNearBottom colorNearTop fillStyle)
('private' buildButton:target:label:selector: wrapPanel:label:)
!


!DownloadingImageMorph class reorganize!
('no messages')
!


!DownloadingImageMorph reorganize!
('accessing' formatter formatter: imageMapName imageMapName:)
('as yet unclassified' altText: defaultExtent: downloadStateIn: setContents setNoImageContents url:)
('initialization' defaultColor initialize)
('stepping and presenter' step)
('testing' stepTime)
!


!ChineseCheckers class reorganize!
('parts bin' descriptionForPartsBin)
!


!ChineseCheckers reorganize!
('accessing' at: at:put:)
('board geometry' boardCenter boardLocAt: cellPointAt: distFrom:to: pieceSize turnIndicatorLoc)
('drag and drop' okToPickUpPieceAt: pieceAt:)
('drawing' drawOn:)
('dropping/grabbing' wantsDroppedMorph:event:)
('event handling' handlesMouseDown: mouseDown:)
('game sequence' nextTurn showNextMoveSegment step)
('geometry' extent:)
('initialization' board:teams: copyBoard defaultColor initialize teams:autoPlay:)
('layout' acceptDroppingMorph:event:)
('menu' addMenuItemsTo:hand: animateMoves dontAnimateMoves newGame reset)
('menus' addCustomMenuItems:hand:)
('moves' allMovesFrom: bestMove:forTeam: checkDoneAfter: endGameFor: jumpFor:from:havingVisited: makeMove: score:for: testDone:for:)
('parts bin' initializeToStandAlone)
('printing' printOn:)
('stepping and presenter')
('testing' stepTime)
!


!ChineseCheckerPiece class reorganize!
('new-morph participation' includeInNewMorphMenu)
!


!ChineseCheckerPiece reorganize!
('all' boardLoc setBoard:loc:)
('dropping/grabbing' justDroppedInto:event:)
('event handling' handlesMouseDown: mouseDown:)
!


!ChessTranspositionTable class reorganize!
('instance creation' new:)
!


!ChessTranspositionTable reorganize!
('initialize' clear initialize: storeBoard:value:type:depth:stamp:)
('lookup' lookupBoard:)
!


!ChessTTEntry class reorganize!
('no messages')
!


!ChessTTEntry reorganize!
('*Refactory-RBAddonsProblem' value)
('accessing' clear depth depth: hashLock hashLock: timeStamp timeStamp: value: valueType valueType:)
!


!ChessPlayerAI class reorganize!
('class initialization' initialize)
!


!ChessPlayerAI reorganize!
('accessing' statusString)
('initialize' activePlayer: initialize initializeTranspositionTable reset reset:)
('searching' copyVariation: mtdfSearch:score:depth: negaScout:depth:alpha:beta: ngSearch:depth:alpha:beta: quiesce:alpha:beta: search:depth:alpha:beta: searchMove:depth:alpha:beta:)
('thinking' isThinking startThinking think thinkProcess thinkStep timeToThink)
!


!ChessPlayer class reorganize!
('accessing' king rook)
('class initialization' initialize initializeBishopMoves initializeCastlingConstants initializeCenterScores initializeConstants initializeKingMoves initializeKnightMoves initializeMoves initializePieceValues initializeRookMoves)
!


!ChessPlayer reorganize!
('*Refactory-RBAddonsReasonable' postCopy)
('accessing' board board: castlingRookSquare castlingStatus enpassantSquare materialValue numPawns opponent opponent: pieceAt: pieces userAgent)
('adding/removing' addBlackPieces addPiece:at: addWhitePieces movePiece:from:to: removePiece:at: replacePiece:with:at:)
('copying' copy copyPlayer:)
('evaluation' evaluate evaluateMaterial evaluatePosition positionalValue)
('initialize' initialize prepareNextMove)
('moves-general' findPossibleMoves findPossibleMovesAt: findQuiescenceMoves findValidMoves findValidMovesAt:)
('moving' applyCastleKingSideMove: applyCastleQueenSideMove: applyDoublePushMove: applyEnpassantMove: applyMove: applyNormalMove: applyPromotion: applyResign: applyStaleMate: updateCastlingStatus:)
('testing' canCastleKingSide canCastleQueenSide isValidMove: isValidMoveFrom:to: isWhitePlayer)
('undo' undoCastleKingSideMove: undoCastleQueenSideMove: undoDoublePushMove: undoEnpassantMove: undoMove: undoNormalMove: undoPromotion: undoResign: undoStaleMate:)
!


!ChessPieceMorph class reorganize!
('no messages')
!


!ChessPieceMorph reorganize!
('dropping/grabbing' wantsToBeDroppedInto:)
!


!ChessMoveList class reorganize!
('no messages')
!


!ChessMoveList reorganize!
('accessing' contents startIndex)
('sorting' sort:to:using: sortUsing:)
('private' on:from:to:)
!


!ChessMoveGenerator class reorganize!
('no messages')
!


!ChessMoveGenerator reorganize!
('initialize' initialize)
('moves-general' moveBishopAt: moveBlackKingAt: moveKingAt: moveKnightAt: movePawnAt: movePiece:along:at: moveQueenAt: moveRookAt: moveWhiteKingAt:)
('moves-pawns' blackPawnCaptureAt:direction: blackPawnPushAt: moveBlackPawnAt: moveWhitePawnAt: promotePawn: whitePawnCaptureAt:direction: whitePawnPushAt:)
('public' attackSquares findAllPossibleMovesFor: findAttackSquaresFor: findPossibleMovesFor: findPossibleMovesFor:at: findQuiescenceMovesFor: kingAttack moveList profileGenerationFor: recycleMoveList:)
('support' canCastleBlackKingSide canCastleBlackQueenSide canCastleWhiteKingSide canCastleWhiteQueenSide)
!


!ChessMove class reorganize!
('accessing' basicMoveMask decodeFrom:)
('class initialization' initialize)
!


!ChessMove reorganize!
('*Refactory-RBAddonsProblem' value)
('accessing' bestMove capturedPiece capturedPiece: destinationSquare destinationSquare: encodedMove moveType moveType: movingPiece movingPiece: promotion sourceSquare sourceSquare: value:)
('comparing' = hash)
('initialize' captureEnPassant:from:to: checkMate: doublePush:from:to: init move:from:to: move:from:to:capture: moveCastlingKingSide:from:to: moveCastlingQueenSide:from:to: moveEncoded: promote:to: staleMate:)
('printing' moveString printOn:)
!


!ChessMorph class reorganize!
('accessing' blackBishopImage blackKingImage blackKnightImage blackPawnImage blackQueenImage blackRookImage whiteBishopImage whiteKingImage whiteKnightImage whitePawnImage whiteQueenImage whiteRookImage)
('parts bin' descriptionForPartsBin)
!


!ChessMorph reorganize!
('drag and drop' dragPiece:from: dragSquareEnter:from: dragSquareLeave:from:)
('drawing' areasRemainingToFill:)
('dropping/grabbing' wantsDroppedMorph:event:)
('events' showMoves:from: showMovesAt:)
('game callbacks' addedPiece:at:white: completedMove:white: finishedGame: gameReset movedPiece:from:to: removedPiece:at: replacedPiece:with:at:white: undoMove:white: validateGamePosition)
('geometry' asSquare: atSquare: squaresDo:)
('initialization' defaultBorderColor defaultBorderWidth defaultBounds defaultColor initialize)
('initialize' addButtonRow addSquares buttonFillStyle buttonName:action: newPiece:white: newSquare)
('layout' acceptDroppingMorph:event:)
('other stuff' rotateBoard statusString)
('playing' autoPlay findBestMove movePieceFrom:to: newGame redoMove thinkAndMove undoMove)
('stepping and presenter' step)
('testing' stepTime)
!


!ChessHistoryTable class reorganize!
('instance creation' new)
!


!ChessHistoryTable reorganize!
('accessing' addMove:)
('initialize' atAllPut: clear)
('sorting' sorts:before:)
!


!ChessBoard class reorganize!
('class initialization' initialize initializeHashKeys)
!


!ChessBoard reorganize!
('*Refactory-RBAddonsReasonable')
('accessing' activePlayer blackPlayer generator searchAgent searchAgent: statusString userAgent userAgent: whitePlayer)
('copying' copy copyBoard: postCopy)
('hashing' hashKey hashLock updateHash:at:from:)
('initialize' initialize initializeNewBoard resetGame)
('moving' movePieceFrom:to: nextMove: nullMove undoMove:)
('printing' printOn:)
!


!AdvancedB3DSceneMorph class reorganize!
('parts bin' descriptionForPartsBin)
!


!B3DSceneMorph class reorganize!
('no messages')
!


!AdvancedB3DSceneMorph reorganize!
('accessing' rotationAngle rotationAngle: scene: stepTime:)
('camera actions' addDolly: addFovAngle: panBy: rotateFrom:to: rotateX: rotateY: rotateZ: transformWithMatrix: updateHeadlight)
('drawing' renderOn:)
('event handling' handlesMouseDown: mouseDown: mouseMove:)
('initialization' initialize)
('initialize' createDefaultScene)
('properties' beRotating beStill headLightIsOn isRotating switchHeadLightOff switchHeadLightOn switchHeadLightStatus switchRotationStatus)
('stepping and presenter' step)
('testing' stepTime)
('private' pointOnSphereCentered:radius:atPoint: updateSceneWithDefaults: updateUpVectorForCamera:)
!


!B3DSceneMorph reorganize!
('accessing' scene scene:)
('drawing' areasRemainingToFill: debugDraw drawAcceleratedOn: drawOn: drawSimulatedOn: forceToScreen renderOn:)
('hardware acceleration' accelerationEnabled accelerationEnabled: accelerationSuspended accelerationSuspended: restoreAcceleration suspendAcceleration)
('initialization' initialize intoWorld: outOfWorld:)
('initialize' createDefaultScene)
('stepping and presenter' step)
('testing' stepTime wantsSteps)
!


!B3DSceneExplorerMorph class reorganize!
('parts bin' descriptionForPartsBin)
!


!B3DSceneExplorerMorph reorganize!
('accessing' accelerationEnabled accelerationEnabled: scene scene:)
('actions' openThreeDSFile selectNewCamera selectNewCamera: switchHeadLightStatus switchRotationStatus toggleAcceleration)
('drawing' drawOn:)
('event handling' handlesMouseDown: mouseDown:)
('initialization' acceleratorButton defaultBorderColor defaultColor initialize)
('layout' layoutChanged)
('menus' addCustomMenuItems: addCustomMenuItems:hand: headLightString rotationString yellowButtonMenu)
!


!B3DMorph class reorganize!
('parts bin' descriptionForPartsBin)
!


!B3DMorph reorganize!
('drawing' drawOn: renderOn:)
('initialization' initialize)
('menu' setTexture)
('menus' addCustomMenuItems:hand:)
('parts bin' initializeToStandAlone)
('stepping and presenter' step)
('testing' stepTime wantsSteps)
!


!AliceTextOutputWindow class reorganize!
('no messages')
!


!AliceTextOutputWindow reorganize!
('initialization' defaultColor initialize)
('output text' addText: addTextOnNewLine:)
!

